<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Request_detail extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
      $this->load->model('driver_suggestion_model');
      $this->load->model('travelcompany/drivers_model');
      $this->load->model('main/requests_model');
      $this->load->model('config/config_model');
  }

    function index() {
      if(!$this->config_model->check_login("ALL")){
          redirect(site_url('travelcompany/log_in'));
      }
    $data['content'] = NULL;
    $data['sidebar'] = NULL;


    $req_id = $_GET['req_id'];
    $where['ds_reqid']=$req_id;
    $data['content'] = $this->driver_suggestion_model->get("*" , $where);
    $this->load->view('travelcompany/req_detail', $data);
  }//end of index function
    function accept() {
        if(!$this->config_model->check_login("COMPANY")){
            redirect(site_url('travelcompany/log_in'));
        }
        date_default_timezone_set('Asia/Tehran');
        $this->load->model('barname_model');

        $where['ds_id'] = $this->uri->segment(4);
        $where['ds_status'] = "1";
        $data['ds_status'] = "1";
        $result = $this->driver_suggestion_model->get("ds_id" , $where);
        if(empty($result)){
            $where_update['ds_id'] = $this->uri->segment(4);
            if( $this->driver_suggestion_model->update($where_update,$data)){

                $result_driverid = $this->driver_suggestion_model->get("ds_driverid , ds_reqid" , $where_update);
                $driverid =$result_driverid[0]->ds_driverid;
                $req_id =$result_driverid[0]->ds_reqid;

                $data_barname_factor['bf_price']=$this->requests_model->get_barname_price($req_id);
                $data_barname_factor['bf_reqid']=$req_id;
                $data_barname_factor['bf_driverid']= $driverid;
                $data_barname_factor['bf_status']="1";
                $data_barname_factor['bf_time_peyment']="30";
                $this->barname_model->insert($data_barname_factor);
                $this->drivers_model->send_sms_by_id($driverid,"2","1");
                $title = "پیشنهاد شما قبول شد";
                $dess = "برای پرداخت برانامه کلیک کنید";
                $this->drivers_model->send_to_drivers("2" , $title , $dess , $driverid , $req_id);
//                $data_req['req_accept_suggestion'] = date('Y/m/d H:i:s', time());
//                $data_req['req_driverid'] = $driverid;
//                $where_req['req_id'] = $req_id;
//                $this->requests_model->update($where_req , $data_req);


                $msg['msg'][0] = 'success';
                $msg['msg'][1] = "با موفقیت ثبت شد.";
                $this->session->set_flashdata($msg);
                redirect(site_url('travelcompany/trip_list')); // TODO
            }else{
                $msg['msg'][0] = "danger";
                $msg['msg'][1] = "خطا در ثبت اطلاعات";
                $this->session->set_flashdata($msg);
                redirect(site_url(array('travelcompany/trip_list')));
            }
        }else{
            echo "<script type=\"text/javascript\">
            alert('شما قبلا این پیشنهاد را پذیرفته اید');
            </script>";
        }


    }//accept





}//end of class
