<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
date_default_timezone_set('Asia/Tehran');


class Webservice extends CI_Controller {

    function __construct() {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->library('session');
        $this->load->database();
    }
    function index() {

    }//end of index function
    
    
    function splash(){
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');

        $driverid = $this->input->post('driverid');
        $firebase_code = $this->input->post('firebase_code');
        $driverlat = $this->input->post('driverlat');
        $driverlng = $this->input->post('driverlng');
        $jsonData['req_id_active'] = "0";
        $valid_driver = $this->drivers_model->submit_driver_information($driverid , $firebase_code , $driverlat ,$driverlng );
        if(empty($valid_driver)){
            $jsonData['status'] = "0"; // sabtenam nakarde
        }else{
            $driver_status = $valid_driver[0]->d_status;
            if($valid_driver[0]->d_verify_code != null){
                $jsonData['status'] = "0"; // need verify mobile
            }
            else if($driver_status == "0"){
                $jsonData['status'] = "1"; // gheire faal hastid
            }
            else if($driver_status == "2"){
                $jsonData['status'] = "2"; // masdod shodeid
            }
            else if($driver_status == "3"){
                $jsonData['status'] = "3"; // driver pak shode
            }else{

                $barname_status = $this->barname_model->get_driver_barnameh($driverid);
                if($barname_status != "0"){
                    $jsonData['status'] = "6";
                    $jsonData['req_id_active'] = $barname_status;
                }else{
                    $req_id  = $this->requests_model->get_driver_req($driverid);
                    if($req_id == "0"){
                        $jsonData['status'] = "4"; // ok va safar faali nadare
                    }else{
                        $jsonData['status'] = "5"; // ok va safar faali DARAD
                        $jsonData['req_id_active'] = $req_id;
                    }
                }
            }
            $jsonData['d_name'] = $valid_driver[0]->d_name;
            $jsonData['d_family'] = $valid_driver[0]->d_family;
            $jsonData['d_mobile'] = $valid_driver[0]->d_mobile;
            $jsonData['d_image'] = $valid_driver[0]->d_image;
            $jsonData['d_company'] = $valid_driver[0]->d_company;
            $jsonData['d_device'] = $valid_driver[0]->d_device;
            $jsonData['d_customer_id'] = $valid_driver[0]->d_customer_id;

        }
        echo json_encode($jsonData);
    }//splash
    function check_driver_mobile()
    {
        $this->load->model('travelcompany/drivers_model');
        $mobile= $this->input->post('mobile');
        $result = $this->drivers_model->check_driver_mobile($mobile);
        if($result == "A"){
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره ی شما در سیستم موجود نمی باشد با مرکز تماس بگیرید";
        }
        else if($result == "B"){
            $jsonData['status'] = "error";
            $jsonData['message'] = "مشکل در برقراری ارتباط یا سامانه پیامکی لطفا دوباره امتحان کنید";
        }
        else {
            $jsonData['status'] = "OK";
            $jsonData['message'] = $result;
        }
        echo json_encode($jsonData);
    }//check_driver_mobile
    function date_convert($miladi_date)
    {
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function
    function check_sms_code()
    {
        $this->load->model('travelcompany/drivers_model');
        $code = $this->input->post('code');
        $driverid = $this->input->post('driverid');

        $where['d_id'] = $driverid ;
        $where['d_verify_code'] = $code ;
        $select = "d_id , d_name , d_family , d_image , d_mobile , d_credit ";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();

        if(empty($result)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "کد ارسالی شما اشتباه می باشد .";
        }else{
            if($this->drivers_model->remove_sms_code($driverid)){
                $jsonData['status'] = "OK";
                $jsonData['d_id'] = $result[0]->d_id;
                $jsonData['d_name'] = $result[0]->d_name;
                $jsonData['d_family'] = $result[0]->d_family;
                $jsonData['d_image'] = $result[0]->d_image;
                $jsonData['d_mobile'] = $result[0]->d_mobile;
                $jsonData['d_credit'] = $result[0]->d_credit;
            }else{
                $jsonData['status'] = "error";
                $jsonData['message'] = "مشکل در برقراری ارتباط  لطفا دوباره امتحان کنید";
            }

        }
        echo json_encode($jsonData);
    }//check_sms_code
    function get_total_info(){

        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');

        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $firebase_code = $this->input->post('firebase_code');

        $this->drivers_model->submit_driver_information($driverid , $firebase_code , $driverlat ,$driverlng );
//        $driver_address = $this->drivers_model->get_address($driverlat,$driverlng,$driverlat,$driverlng);
        $driver_address = "";



        $driverid = $this->input->post('driverid');

        $req_unread = $this->requests_model->get_req_unread($driverid,$driverlat ,$driverlng);
        $active_barname = $this->barname_model->get_active_barnameh_count($driverid);;


        $where['d_id'] = $driverid ;
        $select = "d_name , d_family , d_credit , d_gift_credit , d_image  , d_mobile , d_customer_id ";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            $jsonData['status'] = "error";
            $jsonData['address'] = $driver_address;
            $jsonData['message'] = "اطلاعات شما یافت نشد با مرکز تماس بگیرید .";
        }else{
            $jsonData['status'] = "OK";
            $jsonData['req_unread'] = $req_unread;
            $jsonData['barname_unread'] = $active_barname;
            $jsonData['address'] = $driver_address;
            $jsonData['d_name'] = $result[0]->d_name;
            $jsonData['d_family'] = $result[0]->d_family;
//            $jsonData['d_credit'] = $result[0]->d_credit + $result[0]->d_gift_credit;
            $jsonData['d_credit'] =  $this->get_user_credit_api($result[0]->d_customer_id);
            $jsonData['d_gift_credit'] = $result[0]->d_gift_credit."0";
            $jsonData['d_image'] = $result[0]->d_image;
            $jsonData['d_mobile'] = $result[0]->d_mobile;
        }
        echo json_encode($jsonData);
    }//send_sms
    function get_user_credit(){
        $driverid = $this->input->post('driverid');
        $where['d_id'] = $driverid ;
        $select = "d_customer_id , d_credit , d_gift_credit";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "اطلاعات شما یافت نشد با مرکز تماس بگیرید .";
        }else{

            $customer_id = $result[0]->d_customer_id;

            $jsonData['status'] = "OK";
            $jsonData['message'] = $this->get_user_credit_api($customer_id);
            $jsonData['gift'] =  $result[0]->d_gift_credit."0";
        }
        echo json_encode($jsonData);
    }//get_user_credit
    function AbrlineToken(){
        $URL = "https://abrlife.com/api/v2/business/login";
        $data = array('username' => 'tdriver', 'password' => '!@#tdriver.admin');

        $options = array(
            'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data)
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($URL, false, $context);
        if ($result === FALSE) {

            return 0;
        }else{
            $result_json = json_decode($result);
            $code = $result_json->status->code ;
            $description = $result_json->status->description ;
            if($code == 200 && $description == 'success'){
                $id = $result_json->data->business->_id ;
                $token = $result_json->data->token ;

                return $token;
            }else{
                $data = $result_json->data ;
                $out['status'] = "OK";
                $out['message'] = $data;
                return 0;
            }
        }
    }//Abrlife_login


    function send_sms_agein(){
        $this->load->model('travelcompany/drivers_model');
        $where['d_id'] = $this->input->post('driverid');
        $res = $this->drivers_model->get("d_verify_code , d_mobile",$where);
//        $mobile= $this->input->post('mobile');
        $result = $this->drivers_model->check_driver_mobile($res[0]->d_mobile);
        if($result == "A"){
            $jsonData['status'] = "error";
            $jsonData['message'] = "شماره ی شما در سیستم موجود نمی باشد با مرکز تماس بگیرید";
        }
        else if($result == "B"){
            $jsonData['status'] = "error";
            $jsonData['message'] = "مشکل در برقراری ارتباط یا سامانه پیامکی لطفا دوباره امتحان کنید";
        }
        else {
            $jsonData['status'] = "ok";
            $jsonData['message'] = $result;
        }
        echo json_encode($jsonData);
    }//send_sms_agein



    function Token(){
        $URL = "https://abrlife.com/api/v2/business/login";
        $data = array('username' => 'tdriver', 'password' => '!@#tdriver.admin');

        $options = array(
            'http' => array(
                'header'  => "Content-type: application/x-www-form-urlencoded\r\n",
                'method'  => 'POST',
                'content' => http_build_query($data)
            )
        );
        $context  = stream_context_create($options);
        $result = file_get_contents($URL, false, $context);
        if ($result === FALSE) {

            return 0;
        }else{
            $result_json = json_decode($result);
            $code = $result_json->status->code ;
            $description = $result_json->status->description ;
            if($code == 200 && $description == 'success'){
                $id = $result_json->data->business->_id ;
                $token = $result_json->data->token ;
                echo $token;
            }else{
                $data = $result_json->data ;
                $out['status'] = "OK";
                $out['message'] = $data;
                echo 0;
            }
        }
    }//Abrlife_login



    function get_user_credit_api($customer_id){

        $Authorization = $this->AbrlineToken();
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/userbalance?customer_id=".$customer_id,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Postman-Token: 87c7ac57-c5aa-41df-9090-66ae7083e20c",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return false ;
        } else {
//            var_dump($response);
            $result_json = json_decode($response);
            $status = $result_json->status->description;
            if($status == "success"){
                $credit = $result_json->data;
                return $credit;
            }else{
                return false ;
            }

        }
    }
    
    
    function get_accept_request(){
        array_map('unlink', glob("path/to/temp/*"));
        $files = glob('path/to/temp/*'); // get all file names
        foreach($files as $file){ // iterate files
          if(is_file($file))
            unlink($file); // delete file
        }
    }
    
    function get_active_requests(){
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');
        $this->load->model('setting_model');


        $jsonData["requests"] = array();

        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $this->load->model('travelcompany/drivers_model');
        $this->drivers_model->submit_driver_information($driverid , NULL  , $driverlat ,$driverlng );
        $this->drivers_model->submit_active_req_visit($driverid);

//        exit();


        $data = $this->requests_model->get_active_request($driverid , $driverlat , $driverlng , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_company"] = $item->req_company;
                $row["req_lat1"] = $item->req_lat1;
                $row["req_lng1"] = $item->req_lng1;
                $row["req_lat2"] = $item->req_lat2;
                $row["req_lng2"] = $item->req_lng2;
                $row["req_address1"] = $item->req_city1;
                $row["req_address2"] = $item->req_city2;
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] =  $this->setting_model->get_setting_name($item->req_bar_vazn) ;
                $row["req_dess"] =  $this->setting_model->get_setting_name($item->req_dess) ;
                $row["req_peyment_kind"] =  $this->setting_model->get_setting_name($item->req_peyment_kind) ;

                $row["req_distancee"] =  $this->setting_model->get_setting_name($item->req_distance) ;

                $row["req_bar_device"] = $item->req_bar_device;
                $row["req_bar_price"] = $item->req_bar_price;
                $row["req_barname_price"] = $item->req_barname_price;
                $row["req_olaviat"] = $item->req_olaviat;
                $row["req_driverid"] = $item->req_driverid;
                $row["req_status"] = $item->req_status;
                $row["req_date_en"] = $item->req_date;
                $row["req_code"] = $item->req_code;
                $row["req_date_fa"] = $this->date_convert($item->req_date);
//                $row["req_distance"] = (int)$item->req_distance;
                $row["req_distance"] = (int)($item->d_distance/1000) ;


                $driver_distance = (int)($item->d_distance/1000);
                $barname_time = $this->barname_model->get_barnameh_dead_time($item->req_id) ;

                $res1526 = $this->get_driver_location($driverid);
                $device = $res1526[0]->d_device;

                $where_req['req_bar_device'] = $device;

//                echo $item->req_id."==>";
//                echo $item->req_send_all;
//                echo "<br>";

                if($item->req_send_all == "1" || $item->req_bar_device == $device) {



                    if ($row["req_distancee"] < $driver_distance) {
                        continue;
                    }
                    else if ($barname_time == "0") {
                        $jsonData["requests"][] = $row;
                    } else if ($barname_time > 900) {
                        $jsonData["requests"][] = $row;
                        $this->barname_model->cancell_barname_by_system($item->req_id);
                    }
                }


            }
        }
        echo json_encode($jsonData);
    }//get_active_requests


    function get_driver_location($driverid){
        $where_req['d_id'] = $driverid;
        $select = "d_lat , d_lng , d_device";
        $this->db->select($select);
        $this->db->where($where_req);
        return $this->db->get('_drivers', NULL, NULL)->result();
    }//get_driver_location

    function driver_suggestion(){
        $this->load->model('driver_suggestion_model');
        $dtat['ds_driverid'] = $this->input->post('driverid');
        $dtat['ds_reqid']  = $this->input->post('req_id');
        $dtat['ds_price']  = $this->input->post('price');
        $dtat['ds_date_fa']  = $this->input->post('date');

        $where['ds_driverid'] = $this->input->post('driverid');
        $where['ds_reqid']  = $this->input->post('req_id');
        $data = $this->driver_suggestion_model->get('*' , $where);
        if(empty($data)){
            if($this->driver_suggestion_model->insert($dtat)){
                $jsonData["status"] = "OK";
            }else{
                $jsonData["status"] = "error";
                $jsonData["message"] = "لطفا دوباره امتحان کنید";
            }
        }else {
            $jsonData["status"] = "error";
            $jsonData["message"] = "درخواست شما قبلا به ثبت رسیده است";
        }
        echo json_encode($jsonData);
    }//driver_suggestion
    function check_driver_suggestion(){
        $this->load->model('driver_suggestion_model');
        $where['ds_driverid'] = $this->input->post('driverid');
        $where['ds_reqid']  = $this->input->post('req_id');
        $data = $this->driver_suggestion_model->get('*' , $where);
        if(empty($data)){
            $jsonData["status"] = "error";

        }else{
            $jsonData["status"] = "OK";
            $jsonData["price"] = $data[0]->ds_price;
            $jsonData["date"] = $data[0]->ds_date_fa;
        }
            echo json_encode($jsonData);
    }//driver_suggestion
    function get_profile_info(){
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('setting_model');
        $where['d_id'] = $this->input->post('driverid');
        $data = $this->drivers_model->get('*', $where);
        if(empty($data)){
            $jsonData["status"] = "error";
            $jsonData["message"] = "چنین کاربری وجود ندارد";

        }else{
            $jsonData["status"] = "OK";
            $jsonData["d_company"] = $this->company_model->get_name_by_id($data[0]->d_company);
            $jsonData["d_device"] = $this->setting_model->get_device_kind($data[0]->d_device);
            $jsonData["d_name"] = $data[0]->d_name;
            $jsonData["d_family"] = $data[0]->d_family;
            $jsonData["d_mobile"] = $data[0]->d_mobile;
            $jsonData["d_mobile_owner"] = $data[0]->d_mobile_owner;
            $jsonData["d_pelak"] = $data[0]->d_pelak;
            $jsonData["d_credit"] = $data[0]->d_credit;
            $jsonData["d_num_card_device"] = $data[0]->d_num_card_device;
            $jsonData["driver_number"] = $data[0]->d_num_card_driver;
        }

        echo json_encode($jsonData);
    }//get_profile_info
    function get_accept_requests(){
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('barname_model');
        $this->load->model('travelcompany/company_model');


        $jsonData["requests"] = array();

        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $this->load->model('travelcompany/drivers_model');
        $this->drivers_model->submit_driver_information($driverid , NULL  , $driverlat ,$driverlng );

        $data = $this->requests_model->get_accept_request($driverid , $driverlat , $driverlng , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_company"] = $item->req_company;
                $row["req_lat1"] = $item->req_lat1;
                $row["req_lng1"] = $item->req_lng1;
                $row["req_lat2"] = $item->req_lat2;
                $row["req_lng2"] = $item->req_lng2;
                $row["req_address1"] = $item->req_city1;
                $row["req_address2"] = $item->req_city2;
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] =  $this->setting_model->get_setting_name($item->req_bar_vazn) ;
                $row["req_dess"] =  $this->setting_model->get_setting_name($item->req_dess) ;
                $row["req_peyment_kind"] =  $this->setting_model->get_setting_name($item->req_peyment_kind) ;
                $row["req_bar_device"] = $item->req_bar_device;
                $row["req_bar_price"] = $item->req_bar_price_driver;
//                $row["req_bar_price"] = $this->barname_model->get_barname_bar_price($item->req_id , $driverid);
                $row["req_barname_price"] = $this->barname_model->get_barname_price($item->req_id , $driverid);
                $row["req_olaviat"] = $item->req_olaviat;
                $row["req_driverid"] = $item->req_driverid;
                $row["req_status"] = $item->req_status;
                $row["req_date_en"] = $item->req_date;
                $row["req_code"] = $item->req_code;
                $row["req_date_fa"] = $this->date_convert($item->req_date);
                $row["req_distance"] = (int)($item->req_distance/1000) . " کیلومتر ";



                $where_cmp['cmp_id'] = $item->req_company;
                $data_cmp = $this->company_model->get("*",$where_cmp);
                if(!empty($data_cmp)){
                    $row["cmp_name"] = $data_cmp[0]->cmp_name;
                    $row["cmp_phone"] = $data_cmp[0]->cmp_phone;
                    $row["cmp_mobile"] = $data_cmp[0]->cmp_mobile;
                    $row["cmp_address"] = $data_cmp[0]->cmp_address;
//                    $row["cmp_lat"] = $data_cmp[0]->cmp_lat;
//                    $row["cmp_lng"] = $data_cmp[0]->cmp_lng;
                }else{
                    $row["cmp_name"] = "";
                    $row["cmp_phone"] = "";
                    $row["cmp_mobile"] = "";
                    $row["cmp_address"] = "";
                }


                if($item->req_status != "6"){
                    $jsonData["requests"][] = $row;
                }
            }
        }
        echo json_encode($jsonData);
    }//get_accept_requests
    function get_finished_requests(){
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('barname_model');
        $this->load->model('travelcompany/company_model');


        $jsonData["requests"] = array();

        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $this->load->model('travelcompany/drivers_model');
        $this->drivers_model->submit_driver_information($driverid , NULL  , $driverlat ,$driverlng );

        $data = $this->requests_model->get_finished_request($driverid , $driverlat , $driverlng , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_company"] = $item->req_company;
                $row["req_lat1"] = $item->req_lat1;
                $row["req_lng1"] = $item->req_lng1;
                $row["req_lat2"] = $item->req_lat2;
                $row["req_lng2"] = $item->req_lng2;
                $row["req_address1"] = $item->req_city1;
                $row["req_address2"] = $item->req_city2;
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] =  $this->setting_model->get_setting_name($item->req_bar_vazn) ;
                $row["req_dess"] =  $this->setting_model->get_setting_name($item->req_dess) ;
                $row["req_peyment_kind"] =  $this->setting_model->get_setting_name($item->req_peyment_kind) ;
                $row["req_bar_device"] = $item->req_bar_device;
                $row["req_bar_price"] = $item->req_bar_price_driver;
//                $row["req_bar_price"] = $this->barname_model->get_barname_bar_price($item->req_id , $driverid);
                $row["req_barname_price"] = $this->barname_model->get_barname_price($item->req_id , $driverid);
                $row["req_olaviat"] = $item->req_olaviat;
                $row["req_driverid"] = $item->req_driverid;
                $row["req_status"] = $item->req_status;
                $row["req_date_en"] = $item->req_date;
                $row["req_code"] = $item->req_code;
                $row["req_date_fa"] = $this->date_convert($item->req_date);
                $row["req_distance"] = (int)($item->req_distance/1000) . " کیلومتر ";


                $where_cmp['cmp_id'] = $item->req_company;
                $data_cmp = $this->company_model->get("*",$where_cmp);
                if(!empty($data_cmp)){
                    $row["cmp_name"] = $data_cmp[0]->cmp_name;
                    $row["cmp_phone"] = $data_cmp[0]->cmp_phone;
                    $row["cmp_mobile"] = $data_cmp[0]->cmp_mobile;
                    $row["cmp_address"] = $data_cmp[0]->cmp_address;
//                    $row["cmp_lat"] = $data_cmp[0]->cmp_lat;
//                    $row["cmp_lng"] = $data_cmp[0]->cmp_lng;
                }else{
                    $row["cmp_name"] = "";
                    $row["cmp_phone"] = "";
                    $row["cmp_mobile"] = "";
                    $row["cmp_address"] = "";
                }


                $jsonData["requests"][] = $row;

            }
        }
        echo json_encode($jsonData);
    }//get_finished_requests

    function get_suggestion_driver(){
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $jsonData["requests"] = array();

        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $this->load->model('travelcompany/drivers_model');
        $this->drivers_model->submit_driver_information($driverid , NULL  , $driverlat ,$driverlng );

        $data = $this->requests_model->get_suggestion_driver($driverid , $driverlat , $driverlng , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["req_id"] = $item->req_id;
                $row["req_company"] = $item->req_company;
                $row["req_lat1"] = $item->req_lat1;
                $row["req_lng1"] = $item->req_lng1;
                $row["req_lat2"] = $item->req_lat2;
                $row["req_lng2"] = $item->req_lng2;
                $row["req_address1"] = $item->req_city1;
                $row["req_address2"] = $item->req_city2;
                $row["req_takhlie"] = $this->setting_model->get_setting_name($item->req_takhlie);
                $row["req_bar_kind"] = $this->setting_model->get_setting_name($item->req_bar_kind);
                $row["req_bar_packet"] = $this->setting_model->get_setting_name($item->req_bar_packet);
                $row["req_bar_vazn"] =  $this->setting_model->get_setting_name($item->req_bar_vazn) ;
                $row["req_dess"] =  $this->setting_model->get_setting_name($item->req_dess) ;
                $row["req_peyment_kind"] =  $this->setting_model->get_setting_name($item->req_peyment_kind) ;
                $row["req_bar_device"] = $item->req_bar_device;
                $row["req_bar_price"] = $item->req_bar_price;
                $row["req_barname_price"] = $item->req_barname_price;
                $row["req_olaviat"] = $item->req_olaviat;
                $row["req_driverid"] = $item->req_driverid;
                $row["req_status"] = $item->req_status;
                $row["req_date_en"] = $item->req_date;
                $row["req_date_fa"] = $this->date_convert($item->req_date);
                $row["req_distance"] = (int)($item->req_distance/1000) . " کیلومتر ";
                $row["ds_price"] = $item->ds_price;
                $row["ds_date_fa"] = $item->ds_date_fa;
                $row["req_code"] = $item->req_code;

                $jsonData["requests"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }//get_suggestion_driver
    function get_online_req_driver()
    {
        $this->load->model('setting_model');
        $this->load->model('main/requests_model');
        $this->load->model('travelcompany/company_model');
        $this->load->model('barname_model');

        $driverid = $this->input->post('driverid');
        $req_id = $this->input->post('req_id');
        $data = $this->requests_model->get_online_req_driver_new($driverid , $req_id);
        if (empty($data)) {
            $jsonData['status'] = "error";
            $jsonData['message'] = "درخواستی وجود ندارد";
        } else if(sizeof($data)>1){
            $jsonData['status'] = "error";
            $jsonData['message'] = "شما دو درخواست فعال داشتید ";

         }else{
            $jsonData['status'] = "OK";
            $jsonData["req_id"] = $data[0]->req_id;//
            $jsonData["req_company"] = $data[0]->req_company;//
            $jsonData["req_lat1"] = $data[0]->req_lat1;//
            $jsonData["req_lng1"] = $data[0]->req_lng1;//
            $jsonData["req_lat2"] = $data[0]->req_lat2;//
            $jsonData["req_lng2"] = $data[0]->req_lng2;//
            $jsonData["req_address1"] = $data[0]->req_address1;//
            $jsonData["req_address2"] = $data[0]->req_address2;//
            $jsonData["req_dess"] = $data[0]->req_dess;//
            $jsonData["req_bar_kind"] = $this->setting_model->get_setting_name($data[0]->req_bar_kind);
            $jsonData["req_bar_packet"] = $this->setting_model->get_setting_name($data[0]->req_bar_packet);
            $jsonData["req_bar_vazn"] =  $this->setting_model->get_setting_name($data[0]->req_bar_vazn) ;
            $jsonData["req_bar_device"] = $data[0]->req_bar_device;//

//            $jsonData["req_bar_price"] = $this->barname_model->get_barname_bar_price($data[0]->req_id , $driverid);
            $jsonData["req_barname_price"] = $this->barname_model->get_barname_price($data[0]->req_id , $driverid);


            $jsonData["req_bar_price"] = $data[0]->req_bar_price_driver;//



            $jsonData["req_olaviat"] = $data[0]->req_olaviat;
            $jsonData["req_peyment_kind"] = $data[0]->req_peyment_kind;
            $jsonData["req_driverid"] = $data[0]->req_driverid;//
            $jsonData["req_status"] = $data[0]->req_status;//
            $jsonData["req_code"] = $data[0]->req_code;//
            $jsonData["req_date_en"] = $data[0]->req_date;//
            $jsonData["req_date_fa"] = $this->date_convert($data[0]->req_date);
            $jsonData["ds_price"] = $data[0]->ds_price;
            $jsonData["ds_date_fa"] = $data[0]->ds_date_fa;


            $where_cmp['cmp_id'] = $data[0]->req_company;
            $data_cmp = $this->company_model->get("*",$where_cmp);
            if(!empty($data_cmp)){
                $jsonData["cmp_name"] = $data_cmp[0]->cmp_name;
                $jsonData["cmp_phone"] = $data_cmp[0]->cmp_phone;
                $jsonData["cmp_mobile"] = $data_cmp[0]->cmp_mobile;
                $jsonData["cmp_address"] = $data_cmp[0]->cmp_address;
                $jsonData["cmp_lat"] = $data_cmp[0]->cmp_lat;
                $jsonData["cmp_lng"] = $data_cmp[0]->cmp_lng;
            }else{
                $jsonData["cmp_name"] = "";
                $jsonData["cmp_phone"] = "";
                $jsonData["cmp_mobile"] = "";
                $jsonData["cmp_address"] = "";
            }


        }
        echo json_encode($jsonData);
    }//get_suggestion_driver
    function change_trip_status(){

        $this->load->model('main/requests_model');

        $driverid = $this->input->post('driverid');
        $req_id = $this->input->post('req_id');

        $where['req_id'] = $req_id ;
        $where['req_driverid'] = $driverid ;
        $where['req_status !='] = "0" ; // cancell nashde bashe
        $where['req_status !='] = "6" ; // etmam safar صاثق
        $select = " * ";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_requests', NULL, NULL)->result();
        if(empty($result)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "اطلاعات شما هم خوانی ندارد با مرکز تماس بگیرید";
        }else{
            $result_change = $this->requests_model->trip_change_status($req_id , $result[0]->req_status , $driverid);
            if($result_change == "0"){
                $jsonData['status'] = "error";
                $jsonData['message'] = "خطا در ثبت اطلاعات لطفا دوباره امتحان کنید ";
            }else {
                $jsonData['status'] = "OK";
                $jsonData['req_status'] = $result_change ;
            }
        }
        echo json_encode($jsonData);
    }//change_trip_status
    function rate_barbari_company(){
        $this->load->model('rate_model');
        $data['rate_driverid'] = $this->input->post('driverid');
        $data['rate_reqid'] = $this->input->post('req_id');
        $data['rate_number'] = $this->input->post('rate_number');
        $data['rate_detail'] = $this->input->post('rate_detail');
        $data['rate_dess'] = $this->input->post('rate_dess');
        if($this->rate_model->insert($data)){
            $jsonData['status'] = "OK";
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = "خطا در ثبت اطلاعات لطفا دوباره امتحان کنید ";
        }
        echo json_encode($jsonData);
    }//rate_barbari_company
    function app_register_driver(){
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('setting_model');
        $this->load->model('setting_app_model');
        $this->load->model('driver_transaction_model');

        $this->load->library('form_validation');
        $this->form_validation->set_rules('mobile','تلفن همراه','required|is_unique[_drivers.d_mobile]');
        $this->form_validation->set_rules('name','name','required');
        $this->form_validation->set_rules('family','family','required');
        $this->form_validation->set_rules('mobile_owner','شماره موبایل صاحب ماشین','required');
        $this->form_validation->set_rules('devive_tag','devive_tag','required');
        $this->form_validation->set_rules('devive_color','devive_color','required');
        $this->form_validation->set_rules('driver_number','driver_number','required|is_unique[_drivers.d_num_card_driver]');
        $this->form_validation->set_rules('devive_number','devive_number','required');
        $this->form_validation->set_rules('device_kind','device_kind','required');

        $this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
        $this->form_validation->set_message('is_unique',' فیلد %s تکراری است');

        if($this->form_validation->run() != FALSE) {


            $data['d_company'] = "1000";
            $data['d_name'] = $this->input->post('name');
            $data['d_family'] = $this->input->post('family');
            $data['d_mobile'] = $this->input->post('mobile');
            $data['d_mobile_owner'] = $this->input->post('mobile_owner');
            $data['d_pelak'] = $this->input->post('devive_tag');
            $data['d_color'] = $this->input->post('devive_color');
            $data['d_num_card_driver'] = $this->input->post('driver_number');
            $data['d_num_card_device'] = $this->input->post('devive_number');
            $device_kind = $this->setting_model->get_deviceid_by_name($this->input->post('device_kind'));
            $data['d_device'] = $device_kind;


            if ($driverid = $this->drivers_model->insert($data)) {
                $this->drivers_model->check_driver_mobile($this->input->post('mobile'));
                $gift_register_driver = $this->setting_app_model->get_register_gift();
                $this->driver_transaction_model->change_credit_gift("1" , $driverid , $gift_register_driver , "1" , "REGISTER_GIFT".$driverid );
                $jsonData['status'] = "OK";
                $jsonData['message'] = $driverid ;
            } else {
                $jsonData['status'] = "error";
                $jsonData['message'] = "خطا در ثبت اطلاعات لطفا دوباره امتحان کنید ";
            }

        }else{
            $a = str_replace("<p>", "\n", validation_errors());
            $b = str_replace("</p>", "", $a);
            $jsonData["status"] = "error";
            $jsonData["message"] = $b;
        }
        echo json_encode($jsonData);
    }//rate_barbari_company
    function edit_profile(){
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('setting_model');

        $this->load->library('form_validation');
        $this->form_validation->set_rules('driverid','driverid','required');
        $this->form_validation->set_rules('device_number','device_number','required');
        $this->form_validation->set_rules('device_kind','device_kind','required');

        $this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
        $this->form_validation->set_message('is_unique',' فیلد %s تکراری است');

        if($this->form_validation->run() != FALSE) {


            $where['d_id'] = $this->input->post('driverid');
            $data['d_num_card_device'] = $this->input->post('device_number');
            $data['d_pelak'] = $this->input->post('pelak');
            $data['d_num_card_driver'] = $this->input->post('driver_number');
            if ($this->input->post('device_kind') != "1000") {
            $device_kind = $this->setting_model->get_deviceid_by_name($this->input->post('device_kind'));
            $data['d_device'] = $device_kind;
            }

            if ($this->drivers_model->update($where , $data)) {
                $jsonData['status'] = "ok";
            } else {
                $jsonData['status'] = "error";
                $jsonData['message'] = "خطا در ثبت اطلاعات لطفا دوباره امتحان کنید ";
            }

        }else{
            $a = str_replace("<p>", "\n", validation_errors());
            $b = str_replace("</p>", "", $a);
            $jsonData["status"] = "error";
            $jsonData["message"] = $b;
        }
        echo json_encode($jsonData);
    }//edit_profile
    function get_device_kind(){
        $this->load->model('setting_model');
        $jsonData["device"] = array();
        $where['set_status'] = "1";
        $where['set_kind'] = "device";
        $data = $this->setting_model->get("set_name , set_id" , $where);
        foreach ($data as $item) {
            $row = array();
            $row["set_name"] = $item->set_name;
            $row["set_id"] = $item->set_id;
            $jsonData["device"][] = $row;
        }
       echo json_encode($jsonData);
    }//get_device_kind
    function get_req_detail()
    {
        $this->load->model('main/requests_model');
        $this->load->model('setting_model');
        $this->load->model('barname_model');
        $this->load->model('setting_app_model');
        $this->load->model('travelcompany/drivers_model');

        $driver_comision = $this->setting_app_model->get_driver_comision();
        $req_id= $this->input->post('req_id');
        $driverid = $this->input->post('driverid');
        $time_dead = $this->barname_model->get_barnameh_dead_time($req_id);
        $time_to_pay = 15*60;
        if($time_dead > $time_to_pay){
            $jsonData['status'] = "error";
            $jsonData['message'] = "زمان پرداخت این درخواست به پایان رسیده است.";
        }
        else{
//            echo "2";
            $data = $this->requests_model->get_req_detail($driverid , $req_id);
            if (empty($data)) {
                $jsonData['status'] = "error";
                $jsonData['message'] = "درخواستی وجود ندارد";
            } else if(sizeof($data)>1){
                $jsonData['status'] = "error";
                $jsonData['message'] = "شما دو درخواست فعال داشتید ";

            }
            else{
                $jsonData['status'] = "OK";
                $jsonData["req_id"] = $data[0]->req_id;//
                $jsonData["req_company"] = $data[0]->req_company;//
                $jsonData["req_lat1"] = $data[0]->req_lat1;//
                $jsonData["req_lng1"] = $data[0]->req_lng1;//
                $jsonData["req_lat2"] = $data[0]->req_lat2;//
                $jsonData["req_lng2"] = $data[0]->req_lng2;//
                $jsonData["req_address1"] = $data[0]->req_address1;//
                $jsonData["req_address2"] = $data[0]->req_address2;//
                $jsonData["req_city1"] = $data[0]->req_city1;//
                $jsonData["req_city2"] = $data[0]->req_city2;//
                $jsonData["req_dess"] = $data[0]->req_dess;//
                $jsonData["req_bar_kind"] = $this->setting_model->get_setting_name($data[0]->req_bar_kind);
                $jsonData["req_bar_packet"] = $this->setting_model->get_setting_name($data[0]->req_bar_packet);
                $jsonData["req_bar_vazn"] =  $this->setting_model->get_setting_name($data[0]->req_bar_vazn) ;
                $jsonData["req_bar_device"] = $data[0]->req_bar_device;//
                $jsonData["req_bar_price"] = $data[0]->req_bar_price_driver;//
                $jsonData["req_barname_price"] = $data[0]->req_barname_price;//
                $jsonData["req_olaviat"] = $data[0]->req_olaviat;
                $jsonData["req_peyment_kind"] = $data[0]->req_peyment_kind;
                $jsonData["req_driverid"] = $data[0]->req_driverid;//
                $jsonData["req_status"] = $data[0]->req_status;//
                $jsonData["req_date_en"] = $data[0]->req_date;//
                $jsonData["req_date_fa"] = $this->date_convert($data[0]->req_date);
                $jsonData["ds_price"] = $data[0]->ds_price;
                $jsonData["ds_date_fa"] = $data[0]->ds_date_fa;
                $jsonData["time_dead"] = $time_dead;


                $barname_peyment = $data[0]->req_barname_price;// mablagh barname
                $driver_peyment = ($driver_comision*$barname_peyment)/100; // komision ranande
                $jsonData["driver_comision"] = $driver_peyment;
                $driver_credit_gift = $this->drivers_model->get_driver_credit_gift($driverid); // etebar hadye
                $customer_id = $this->drivers_model->get_driver_customer_id($driverid);
                $driver_credit = $this->get_user_credit_api($customer_id); // etebar asli
//                $driver_credit = 2000 ;
                $driver_credit = $driver_credit / 10 ;
//
                $total_peyment = ($barname_peyment+$driver_peyment);
                $dess = "مبلغ بارنامه و کارمزد برابر با ";
                $dess .= $total_peyment;
                $dess .= " تومان می باشد . ";
                if($driver_credit_gift != 0 && $driver_credit_gift > 0){
                    if($driver_credit_gift >= $driver_peyment){
                        $total_peyment = $total_peyment - $driver_peyment ;
                        $dess .= "که از این مبلغ  معادل ";
                        $dess .= $driver_peyment;
                        $dess .= " تومان از اعتبار هدیه شما کسر خواهد شد ";

                    }else{
                        $total_peyment = $total_peyment - $driver_credit_gift ;
                        $dess .= "که از این مبلغ  معادل ";
                        $dess .= $driver_credit_gift;
                        $dess .= " تومان از اعتبار هدیه شما کسر خواهد شد ";
                    }

                }

                if($driver_credit > 0){

                    if($driver_credit > $total_peyment ){
                        $dess .= " و مبلغ ";
                        $dess .= $total_peyment;
                        $dess .= " تومان از اعتبار اصلی شما کسر میشود  ";
                        $total_peyment = 0 ;

                    }else{
                        $total_peyment = $total_peyment - $driver_credit ;
                        $dess .= " و مبلغ ";
                        $dess .= $driver_credit;
                        $dess .= " تومان از اعتبار اصلی شما کسر میشود  ";
                    }



                }

                $dess .= "مبلغ قابل پرداخت برابر است با ";
                $dess .= $total_peyment;
                $dess .= " تومان ";
                $dess .= "";
                $jsonData["total_peyment"] = $total_peyment;
                $jsonData["peyment_dess"] = $dess;
            }

        }

        echo json_encode($jsonData);
    }//get_suggestion_driver
    function Abrlife_get_credit($customer_id){

        $Authorization = $this->AbrlineToken();
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/userbalance?customer_id=".$customer_id,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Postman-Token: 87c7ac57-c5aa-41df-9090-66ae7083e20c",
                "cache-control: no-cache"
            ),
        ));
        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        if ($err) {
            echo "cURL Error #:" . $err;
        } else {
            echo $response;
        }
    }//Abrlife_get_credit
    function cancell_suggestion(){
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');
        $req_id= $this->input->post('req_id');
        $driverid = $this->input->post('driverid');
        if($this->barname_model->cancell_suggestion_by_driver($req_id,$driverid)){
            $jsonData['status'] = "OK";
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = "لطفا دوباره امتحان کنید";
        }
        echo json_encode($jsonData);
    }//cancell_suggestion
    function check_peyments(){
        $this->load->model('barname_model');
        $this->load->model('main/requests_model');
        $req_id= $this->input->post('req_id');
        $driverid = $this->input->post('driverid');
        $barname_status = $this->barname_model->get_driver_barnameh($driverid);
        if($barname_status != "0"){
            $jsonData['status'] = "error";
        }else{
            $req_id  = $this->requests_model->get_driver_req($driverid);
            if($req_id == "0"){
                $jsonData['status'] = "error"; // ok va safar faali nadare
            }else{
                $jsonData['status'] = "OK"; // ok va safar faali DARAD
            }
        }
        echo json_encode($jsonData);
    }//check_peyments
    function accept_suggestion(){
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');
        $this->load->model('setting_app_model');
        $this->load->model('driver_transaction_model');
        $this->load->model('travelcompany/drivers_model');

        $amount = $this->input->post('amount');
        $amount = $amount*10;
        $req_id= $this->input->post('req_id');
        $driverid = $this->input->post('driverid');

        $status = $this->barname_model->allow_peyment_driver($req_id);
        if($status == "0"){
            if($amount == 0){
                $this->back_bank_with_credit($driverid,$req_id);
                $jsonData['status'] = "GOOD";
                $jsonData['message'] = "";
            }else{
                $url = $this->Barname_peyment_bank($driverid,$amount,$req_id);
                $jsonData['status'] = "OK";
                $jsonData['message'] = $url;
            }
        }else{
            switch ($status){
                case "1":
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "بارنامه پرداخت شده است";

                    break;
                case "2":
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "زمان پرداخت بارنامه به اتمام رسیده است";
                    break;
                case "3":
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "درخواست لغو یا توسط راننده ی دیگری انجام می شود";
                    break;
                case "4":
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "*****";
                    break;
            }
        }
        echo json_encode($jsonData);

    }//cancell_suggestion
    function test_bank(){
        $url = $this->Barname_peyment_bank("24","1000","159");
        echo $url ;
    }
    function back_bank_with_credit($driverid,$req_id){

        $this->load->model('bank_model');
        $this->load->model('setting_app_model');
        $this->load->model('barname_model');
        $this->load->model('driver_transaction_model');
        $this->load->model('company_transaction_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');




            $company_id = $this->requests_model->get_company_id($req_id);

            $driver_comision = $this->setting_app_model->get_driver_comision();
            $barname_price = $this->barname_model->get_barname_price($req_id , $driverid);
            $driver_peyment = ($driver_comision*$barname_price)/100; // komision ranande
            $customer_id = $this->drivers_model->get_driver_customer_id($driverid);
            $driver_credit_gift = $this->drivers_model->get_driver_credit_gift($driverid); // etebar hadye
            $driver_credit = $this->get_user_credit_api($customer_id); // etebar asli

            $total_peyment = $driver_peyment + $barname_price ;// az hesab asli kam beshe 105/000
            $gif_minus = 0 ;// az hesabe gift kam beshe
            $price_karmozd = 0 ;

            if($driver_credit_gift>0 && $driver_credit_gift>=$driver_peyment){
                $total_peyment = $barname_price; // 100/000
                $gif_minus = $driver_peyment ;
                $price_karmozd = 0 ;
            }
            else if($driver_credit_gift>0) {
                $total_peyment = $total_peyment - $driver_credit_gift;
                $gif_minus = $driver_credit_gift ;
                $price_karmozd = $driver_peyment - $driver_credit_gift;
            }
            else if($driver_credit_gift==0) {
                $price_karmozd = $driver_peyment ;
            }

            $res = $this->sharingtransfer($customer_id,$total_peyment,"tdriver/driver_wage","tdriver/barname",$price_karmozd,$barname_price);
            if($res){
                $date['dess'] = $req_id ."______".$driverid;
                $this->bank_model->insert($date);


                $new_credit = $this->get_user_credit_api($customer_id);

                $data_cmpt['cmpt_kind']="1";
                $data_cmpt['cmpt_price']=$barname_price;
                $data_cmpt['cmpt_req_id']=$req_id;
                $data_cmpt['cmpt_cmp_id']=$company_id;
                $this->company_transaction_model->insert($data_cmpt);

                $this->driver_transaction_model->add_driver_transaction("1" , $driverid , $total_peyment , "3" , "PAY_BARNAMEH".$req_id , $new_credit );

                $this->driver_transaction_model->change_credit_gift("2" , $driverid , $gif_minus , "4" , "PAY_COMISION".$req_id );

                if($this->barname_model->accept_suggestion_by_driver($req_id,$driverid)){
                    $jsonData['status'] = "GOOD";
                }else{
                    $jsonData['status'] = "error";
                    $jsonData['message'] = "لطفا دوباره امتحان کنید";
                }

            }else{
                $date['dess'] = $res;
                $this->bank_model->insert($date);
            }

    }



    function back_bank($customer_id , $amount , $track_id){





        $this->load->model('bank_model');
        $this->load->model('setting_app_model');
        $this->load->model('barname_model');
        $this->load->model('company_transaction_model');
        $this->load->model('driver_transaction_model');
        $this->load->model('travelcompany/drivers_model');
        $this->load->model('main/requests_model');


//            $date['dess'] = $staus;
//            $this->bank_model->insert($date);

//            $amount = $this->input->post('amount');
//            $track_id= $this->input->post('track_id');
            $exp = explode("_",$track_id);
            $req_id = $exp[0];
            $driverid = $exp[1];

            $date['dess'] = $req_id ."______".$driverid;
            $this->bank_model->insert($date);

            $company_id = $this->requests_model->get_company_id($req_id);
            $driver_comision = $this->setting_app_model->get_driver_comision();
            $barname_price = $this->barname_model->get_barname_price($req_id , $driverid);
            $driver_peyment = ($driver_comision*$barname_price)/100; // komision ranande
            $customer_id = $this->drivers_model->get_driver_customer_id($driverid);
            $driver_credit_gift = $this->drivers_model->get_driver_credit_gift($driverid); // etebar hadye
            $driver_credit = $this->get_user_credit_api($customer_id); // etebar asli

            $total_peyment = $driver_peyment + $barname_price ;// az hesab asli kam beshe 105/000
            $gif_minus = 0 ;// az hesabe gift kam beshe
            $price_karmozd = 0 ;

            if($driver_credit_gift>0 && $driver_credit_gift>=$driver_peyment){
                $total_peyment = $barname_price; // 100/000
                $gif_minus = $driver_peyment ;
                $price_karmozd = 0 ;
            }
            else if($driver_credit_gift>0) {
                $total_peyment = $total_peyment - $driver_credit_gift;
                $gif_minus = $driver_credit_gift ;
                $price_karmozd = $driver_peyment - $driver_credit_gift;
            }
            else if($driver_credit_gift==0) {
                $price_karmozd = $driver_peyment ;
            }

//           echo $customer_id."<br>";
//           echo $total_peyment."<br>";
//           echo $price_karmozd."<br>";
//           echo $barname_price."<br>";
//           echo $driverid."<br>";
//           echo $total_peyment."<br>";
//           echo $req_id."<br>";
           echo $company_id."<br>";

            $res = $this->sharingtransfer($customer_id,$total_peyment,"tdriver/driver_wage","tdriver/barname",$price_karmozd,$barname_price);
            var_dump($res);

                if($res){

                $new_credit = $this->get_user_credit_api($customer_id);
                $this->driver_transaction_model->add_driver_transaction("1" , $driverid , $total_peyment , "3" , "PAY_BARNAMEH".$req_id , $new_credit );

                $this->driver_transaction_model->change_credit_gift("2" , $driverid , $gif_minus , "4" , "PAY_COMISION".$req_id );


                    $data_cmpt['cmpt_kind']="1";
                    $data_cmpt['cmpt_price']=$barname_price;
                    $data_cmpt['cmpt_req_id']=$req_id;
                    $data_cmpt['cmpt_cmp_id']=$company_id;
                    $this->company_transaction_model->insert($data_cmpt);


                if($this->barname_model->accept_suggestion_by_driver($req_id,$driverid)){
//                    $jsonData['status'] = "OK";
                    echo "با موفقیت پرداخت شد";
                }else{
//                    $jsonData['status'] = "error";
//                    $jsonData['message'] = "لطفا دوباره امتحان کنید";
                    echo "عملیات به درستی انجام نشد";
                }

            }else{
                $date['dess'] = $res;
                $this->bank_model->insert($date);
                echo "عملیات به درستی انجام نشد";
            }

    }//back_bank

    function sharingtransfer($customer_id="tdriver/09120917777" , $amount=1000 , $customer_id1="tdriver/09120917577" ,
                             $customer_id2="tdriver/09120917576" , $amount1=700 , $amount2=300){

//        echo $customer_id ;
//        echo "<br>";
//        echo $amount ;
//        echo "<br>";
//        echo $customer_id1 ;
//        echo "<br>";
//        echo $customer_id2 ;
//        echo "<br>";
//        echo "amount1=>" .$amount1 ;
//        echo "<br>";
//        echo "amount2=>" .$amount2 ;
//        echo "<br>";

        $amount = $amount * 10 ;
        $amount1 = $amount1 * 10 ;
        $amount2 = $amount2 * 10 ;

        $Authorization = $this->AbrlineToken();

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/sharingtransfer",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "{\n\t\"sender_customer_id\":\"$customer_id\",\n\t\"receiver_customer_ids\":[\"$customer_id1\",\"$customer_id2\"],\n\t\"amount\":$amount,\n\t\"type\":\"transfer\",\n\t\"divide_type\":\"fixed\",\n\t\"divide_amounts\":[$amount1,$amount2],\n\t\"sender_comment\":\"purchase subscription\"\n}",
            CURLOPT_POST => true,
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Content-Type: application/json",
                "Postman-Token: 732dc300-8720-42e5-a811-0f2255878c0f",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);

        var_dump($response);

        if ($err) {
            return false ;
        } else {
            $result_json = json_decode($response);
            $status = $result_json->status->description;
            if($status == "success"){
                return true ;
            }
            else{
                return false ;
            }
        }

    }//userwithdraw
    function Barname_peyment_bank($driverid ,$amount , $reqid ){

        $this->load->model('travelcompany/drivers_model');
        $customer_id = $this->drivers_model->get_driver_customer_id($driverid);
        $url= "http://tdriver.ir/app/index.php/webservice/webservice/back_bank";
        $track_id= $reqid."_".$driverid;

        ini_set ( "soap.wsdl_cache_enabled", "0" );
        $order_id = time();

        $PIN = 'wM17bc63u2CDbK7CLKWT';
        $wsdl_url = "https://pec.shaparak.ir/NewIPGServices/Sale/SaleService.asmx?WSDL";
        $site_call_back_url = "http://tdriver.ir/app/index.php/webservice/webservice/back_user_increase_parsian?t_id=".$track_id."&cm_id=".$customer_id."&amount=".$amount;

        $params = array (
            "LoginAccount" => $PIN,
            "Amount" => $amount,
            "OrderId" => $order_id,
            "CallBackUrl" => $site_call_back_url
        );

        $client = new SoapClient ( $wsdl_url );

        try {
            $result = $client->SalePaymentRequest ( array (
                "requestData" => $params
            ) );
            if ($result->SalePaymentRequestResult->Token && $result->SalePaymentRequestResult->Status === 0) {
                $url =  "https://pec.shaparak.ir/NewIPG/?Token=" . $result->SalePaymentRequestResult->Token ;
                return $url ;
            }
            elseif ( $result->SalePaymentRequestResult->Status  != '0') {
                $err_msg = "(<strong> کد خطا : " . $result->SalePaymentRequestResult->Status . "</strong>) " .
                    $result->SalePaymentRequestResult->Message ;
                return "0" ;
            }
        } catch ( Exception $ex ) {
            $err_msg =  $ex->getMessage()  ;
            return "0" ;
        }


    }//userincreasebalance



    function back_user_increase_parsian(){
        $amount = $this->input->get("amount");
        $t_id = $this->input->get("t_id");
        $cm_id = $this->input->get("cm_id");


        $PIN = 'wM17bc63u2CDbK7CLKWT';
        $wsdl_url = "https://pec.shaparak.ir/NewIPGServices/Confirm/ConfirmService.asmx?WSDL";

        $Token = $_REQUEST ["Token"];
        $status = $_REQUEST ["status"];
        $OrderId = $_REQUEST ["OrderId"];
        $TerminalNo = $_REQUEST ["TerminalNo"];
        $Amount = $_REQUEST ["Amount"];
        $RRN = $_REQUEST ["RRN"];

        if ($RRN > 0 && $status == 0) {

            $params = array (
                "LoginAccount" => $PIN,
                "Token" => $Token
            );

            $client = new SoapClient ( $wsdl_url );

            try {
                $result = $client->ConfirmPayment ( array (
                    "requestData" => $params
                ) );
                if ($result->ConfirmPaymentResult->Status != '0') {
                    $err_msg = "(<strong> کد خطا : " . $result->ConfirmPaymentResult->Status . "</strong>) " .
                        $result->ConfirmPaymentResult->Message ;
                    echo $err_msg;
                }else{
                    $this->userincreasebalance_noipg($cm_id , $amount , $t_id);

                }
            } catch ( Exception $ex ) {
                $err_msg =  $ex->getMessage()  ;
                echo $err_msg;
            }
        }elseif($status) {
            $err_msg = "کد خطای ارسال شده از طرف بانک $status " . "";
            echo $err_msg;
        }else {
            $err_msg = "پاسخی از سمت بانک ارسال نشد " ;
            echo $err_msg;
        }


    }//back_user_increase_parsian


    function userincreasebalance_noipg($customer_id , $amount , $t_id){

        $url= "https://abrlife.com/api/v2/business/userincreasebalance_noipg";
        $track_id= "002";
        $Authorization = $this->AbrlineToken();

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "https://abrlife.com/api/v2/business/userincreasebalance_noipg",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => "{\n\t\"customer_id\":\"$customer_id\",\n\t\"amount\":\"$amount\",\n\t\"url\":\"$url\",\n\t\"track_id\":\"$track_id\"\n}",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Content-Type: application/json",
                "Postman-Token: 3c6a7538-b6fb-44c3-b1b5-5af7ec83e413",
                "cache-control: no-cache"
            ),
        ));

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            $jsonData['status'] = "error";
            $jsonData['message'] = $err;
            echo json_encode($jsonData);

        } else {
            $this->back_bank($customer_id , $amount , $t_id);
//            $result_json = json_decode($response);
//            $jsonData['status'] = "OK";
////            $jsonData['url'] = "https://abrlife.com/bank?refId=".$result_json->data;
//            $jsonData['result_json'] = $result_json;
//            echo "با موفقیت انجام شد";
        }
//        echo json_encode($jsonData);

    }//userincreasebalance




    function cancell_trip_driver(){
        $this->load->model('main/requests_model');
        $this->load->model('barname_model');
        $this->load->model('setting_app_model');
        $this->load->model('driver_transaction_model');
        $req_id= $this->input->post('req_id');
        $driverid = $this->input->post('driverid');
        $barname_price = $this->barname_model->get_barname_price($req_id , $driverid);
        $persent_return = 100 -  $this->setting_app_model->get_register_gift();
        $credit_increase = ($barname_price * $persent_return) / 100 ;
        if($this->driver_transaction_model->change_credit("1" , $driverid , $credit_increase , "2" , "RETURN_BARNAMEH".$req_id )){
            $where['req_id'] = $req_id;
            $where['req_driverid'] = $driverid;
            $data['req_status'] = "0";
            if($this->requests_model->update($where,$data)){
                $jsonData['status'] = "OK";
            }else{
                $jsonData['status'] = "error";
                $jsonData['message'] = "لطفا دوباره امتحان کنید";
            }
        }else{
            $jsonData['status'] = "error";
            $jsonData['message'] = "لطفا دوباره امتحان کنید";
        }
        echo json_encode($jsonData);
    }//cancell_trip_driver


    function get_driver_transaction(){
        $this->load->model('driver_transaction_model');
        $this->load->model('travelcompany/drivers_model');
        $jsonData["transaction"] = array();

        $driverid = $this->input->post('driverid');
//        $driverlat = $this->input->post('lat');
//        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $customer_id = $this->drivers_model->get_driver_customer_id($driverid);

        $data = $this->driver_transaction_model->get_driver_transaction($driverid  , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "تراکنشی وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["dt_id"] = $item->dt_id;
                $row["dt_driverid"] = $item->dt_driverid;
                $row["dt_price"] = $item->dt_price;
                $row["dt_new_credit"] = $item->dt_new_credit;
                $row["dt_status"] = $item->dt_status;
                $row["dt_date_en"] = $item->dt_date;
                $row["dt_date_fa"] = $this->date_convert($item->dt_date);
                $row["dt_code1"] = $item->dt_code1;
                $row["dt_code2"] = $item->dt_code2;
                $row["dt_code3"] = $item->dt_code3;
                $row["dt_kind"] = $item->dt_kind;
                $jsonData["transaction"][] = $row;
            }
        }

//        $transaction = $this->get_dargah_transaction($customer_id);
//       var_dump($transaction);
//        if(!empty($transaction)){
//            $jsonData['status'] = "ok";
//            foreach ($transaction as $item) {
//                $row = array();
//                $row["dt_id"] = "0";
//                $row["dt_driverid"] = $driverid;
//                $row["dt_price"] = $item->outcome;
//                $row["dt_new_credit"] = $item->outcome;
//                $row["dt_status"] = "";
//                $date = date('Y-m-d H:i:s', $item->create_at/1000);
//                $row["dt_date_en"] = $date;
//                $row["dt_date_fa"] = $this->date_convert($date);
//                $row["dt_code1"] = "";
//                $row["dt_code2"] =  "";
//                $row["dt_code3"] =  "";
//                $row["dt_kind"] =  "8";
//                $jsonData["transaction"][] = $row;
//            }
//        }


        echo json_encode($jsonData);
    }//get_driver_transaction




    function get_dargah_transaction($customer_id){
        $Authorization = $this->AbrlineToken();
//        $customer_id = "tdriver/09120917777";
        $datetime = new DateTime();
        $end_date =  $datetime->getTimestamp()*1000;
        $type = "transfer";
        $end_date = "1548227310000";

        $url = "https://abrlife.com/api/v2/business/usertransaction?customer_id=".$customer_id.
            "&start_date=1538761700000&end_date=".$end_date."&type=".$type;
//        echo $url;

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $url ,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => array(
                "Authorization: " . $Authorization,
                "Postman-Token: 87c7ac57-c5aa-41df-9090-66ae7083e20c",
                "cache-control: no-cache"
            ),
        ));
        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        if ($err) {
            echo "cURL Error #:" . $err;
        } else {
            $result_json = json_decode($response);
            $transactions = $result_json->data->transactions;
            return $transactions;
//           var_dump($transactions);
        }
    }

    function get_driver_barname_factor(){
        $this->load->model('barname_model');
        $jsonData["barnameh"] = array();

        $bf_id = $this->input->post('bf_id');
        $driverid = $this->input->post('driverid');
        $driverlat = $this->input->post('lat');
        $driverlng = $this->input->post('lng');
        $offset = $this->input->post('offset');
        $limit = $this->input->post('limit');

        $data = $this->barname_model->get_driver_barname_factor($bf_id , $driverid  , $offset , $limit);
        if(empty($data)){
            $jsonData['status'] = "error";
            $jsonData['message'] = "بارنامه ای وجود ندارد";
        }else {
            $jsonData['status'] = "ok";
            foreach ($data as $item) {
                $row = array();
                $row["bf_id"] = $item->bf_id;
                $row["bf_price"] = $item->bf_price;
                $row["bf_reqid"] = $item->bf_reqid;
                $row["bf_driverid"] = $item->bf_driverid;
                $row["bf_date_en"] = $item->bf_date;
                $row["bf_date_fa"] = $this->date_convert($data[0]->bf_date);
                $row["bf_status"] = $item->bf_status;
                $row["bf_time_peyment"] = $item->bf_time_peyment;
                $row["bf_peyment_date"] = $item->bf_peyment_date;
                $row["bf_code"] = $item->bf_code;
                $row["bf_cancell_time"] = $item->bf_cancell_time;
                $jsonData["barnameh"][] = $row;
            }
        }
        echo json_encode($jsonData);
    }//get_driver_transaction
    function test_dead_time(){
        $this->load->model('barname_model');
        $time =  $this->barname_model->get_barnameh_dead_time("10");
        echo "   seconds=>" . ($time);
        echo "   minute=>" . (($time)/60);
        echo "   hour=>" . ((($time)/60)/60);
        echo "   day=>" . (((($time)/60)/60)/24);
    }
    function set_driver_status(){

    }//set_driver_status
    function get_active_barname(){
        $this->load->model('barname_model');
        $driverid = $this->input->post('driverid');
        $data = $this->barname_model->get_active_barnameh($driverid);
//        var_dump($data);
        echo json_encode($data);
    }//get_active_barname


}//end of class
