<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Comment_support_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		
                $this->db->join('users', 'users.usr_id=comment.userid', 'left');
                $this->db->join('support', 'support.id=comment.support_id', 'left');


		return $this->db->get('comment', $limit, $offset)->result();
	}
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update("comment", $data))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert("comment", $data))
			return TRUE;
		else
			return FALSE;
	}
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete("comment"))
			return TRUE;
		else
			return FALSE;
	}
	
}