<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class online_trip_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL , $group_by= NULL , $or_like = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
			
		if($where != NULL)
			$this->db->where($where);
			
		if($or_like != NULL)
			$this->db->or_like($or_like);
			
		if($order_by != NULL)
			$this->db->order_by($order_by);

		if($group_by!= NULL)
			$this->db->group_by($group_by);


		
		return $this->db->get('trip_online', $limit, $offset)->result();

	}
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update("trip_online", $data))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert("trip_online", $data))
			return $this->db->insert_id();
		else
			return FALSE;
	}
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete("trip_online"))
			return TRUE;
		else
			return FALSE;
	}
	
}