<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Colleague_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_colleague', $limit, $offset)->result();
	}


    function get_colleague_name($co_id)
    {
        $where['co_id'] = $co_id ;
        $this->db->select("co_name , co_family");
        $this->db->where($where);
        $data =  $this->db->get('_colleague')->result();
        if(empty($data)){
            return " - - - " ;
        }else{
            return $data[0]->co_name . " " . $data[0]->co_family;
        }
    }


	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_colleague', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_colleague'))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('_colleague', $data))
			return TRUE;
		else
			return FALSE;
	}

	
}//end of class