let element = document.getElementById("googleMap");
let map= new google.maps.Map(element, {
    center:new google.maps.LatLng(30.6683830,51.5875230),
    zoom:15,
    mapTypeId: "ParsijooMap",
    mapTypeControl: false,
    streetViewControl: false
});
//Define Parsijoo map type pointing at the ParsijooMap tile server
map.mapTypes.set("ParsijooMap", new google.maps.ImageMapType({
    getTileUrl: function(coord, zoom) {
        // "Wrap" x (logitude) at 180th meridian properly
        // NB: Don't touch coord.x because coord param is by reference, and changing its x property breakes something in Google's lib
        let tilesPerGlobe = 1 << zoom;
        let x = coord.x % tilesPerGlobe;
        if (x < 0) {
            x = tilesPerGlobe+x;
        }
        // Wrap y (latitude) in a like manner if you want to enable vertical infinite scroll

        return "https://developers.parsijoo.ir/web-service/v1/map/?type=tile"+"&" +"x=" + x + "&" +"y=" + coord.y + "&" +"z=" + zoom +"&" + "apikey=5fc16a18cdc444c3b28996ea1fc7198f";
    },
    tileSize: new google.maps.Size(256, 256),
    name: "ParsijooMap",
    maxZoom: 18
}));