<html>
<head>
	<title></title>
	<script src="https://code.jquery.com/jquery-1.10.2.js"></script>
	<script src="http://maps.googleapis.com/maps/api/js?callback=initMap"></script>
	<script>
	var markersArray = [];
	var iCount = -1;
	function initialize() {
		var mapProp = {
	  		center:new google.maps.LatLng("<?php echo $location['latitude']; ?>", "<?php echo $location['longitude']; ?>"),
	    	zoom:13,
	    	mapTypeId:google.maps.MapTypeId.ROADMAP
		};
		var map=new google.maps.Map(document.getElementById("googleMap"),mapProp);
		var marker1 = new google.maps.Marker({
            draggable: true,
            icon : 'http://snapp1855.com/admin/app/template_inc/img/icon/wa_first.png' ,
	    	position: new google.maps.LatLng("<?php echo $location['latitude']; ?>", "<?php echo $location['longitude']; ?>"),
	    	map: map,
		});


		markersArray.push(marker1);

	  	iCount++;

        google.maps.event.addListener(marker1, 'click', (function (event) {
            placeMarker(event.latLng);
        }));


		// google.maps.event.addListener(map, 'click', function(event) {
		// 	placeMarker(event.latLng);
		// });
		function placeMarker(location) {
			$("#first_lat").val(location.lat());
			$("#first_lng").val(location.lng());

            var marker1 = new google.maps.Marker({
                draggable: true,
                icon : 'http://snapp1855.com/admin/app/template_inc/img/icon/wa_first.png' ,
                position: new google.maps.LatLng(location.lat(), location.lng()),
                map: map,
            });

            var marker2 = new google.maps.Marker({
                draggable: true,
                icon : 'http://snapp1855.com/admin/app/template_inc/img/icon/wa_second.png' ,
                position: new google.maps.LatLng("<?php echo $location['latitude']; ?>", "<?php echo $location['longitude']; ?>"),
                map: map,
            });

            markersArray.push(marker1);
            markersArray.push(marker2);

		  	iCount++;
		  	if(markersArray.length > 1)
		  	{
		  		markersArray[iCount - 1].setMap(null);
		  	}

		  	var geocoder;
		      geocoder = new google.maps.Geocoder();
		      var latlng = new google.maps.LatLng(location.lat(), location.lng());

		      geocoder.geocode(
		          {'latLng': latlng}, 
		          function(results, status) {
		              if (status == google.maps.GeocoderStatus.OK) {
		                      if (results[0]) {
		                          var add= results[0].formatted_address ;
		                          var  value=add.split(",");

		                          count=value.length;
		                          country=value[count-1];
		                          state=value[count-2];
		                          city=value[count-3];
		                          $("#city").val(city);
		                      }
		                      else  {
		                          // alert("address not found");
		                      }
		              }
		               else {
		                  // alert("Geocoder failed due to: " + status);
		              }
		          }
		      );

		}//end of placeMarker function
		//end of 111
	}//end of initialize function
	google.maps.event.addDomListener(window, 'load', initialize);
	</script>
</head>
<body>
	<div id="googleMap" style="width:100%;height:400px;"></div>
</body>
</html>