<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Dashboard extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->library('session');
        $this->load->database();
        $this->load->model('config/config_model');
    }

    function index()
    {
        $this->config_model->check_login("ADMIN");
        $data['users_count'] = "";
        $data['admins_count'] = "";
        $data['experts_count'] = "";
        $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
        $this->load->view('dashboard_list', $data);
    }//end of index function


}//end of class