<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Requests extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
    $this->load->model('main/requests_model');
    $this->load->model('driver_suggestion_model');
    $this->load->model('setting_model');
      $this->load->model('travelcompany/colleague_model');
      $this->load->model('travelcompany/city_model');
      $this->load->model('travelcompany/company_model');
      $this->load->model('setting_model');

  }

  function index() {
      $this->config_model->check_login("COMPANY");

      $where_peyment_kind["set_kind"] = "peyment_kind";
      $where_peyment_kind["set_status"] = "1";
      $data['peyment_kind'] = $this->setting_model->get('set_id , set_name' , $where_peyment_kind );

      $where_device["set_kind"] = "device";
      $where_device["set_status"] = "1";
      $data['device'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "bar_kind";
      $data['bar_kind'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "bar_packet";
      $data['bar_packet'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "bar_weight";
      $data['bar_weight'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "bar_dess";
      $data['bar_dess'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "distance";
      $data['distance'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $where_device["set_kind"] = "takhlie";
      $data['takhlie'] = $this->setting_model->get('set_id , set_name' , $where_device );


      $where_device["set_kind"] = "device";
      $where_device["set_status"] = "1";
      $data['device'] = $this->setting_model->get('set_id , set_name' , $where_device );

      $data['cities'] = $this->city_model->get('id , name');
      $data['company'] = $this->company_model->get('cmp_id , cmp_name');



      $data['sidebar'] = $this->load->view("side_bar", "", TRUE);
      $this->load->view('requests_list', $data);
  }//end of index function



    function  suggestion(){
        $data['pagination'] = NULL ;
    $where['ds_reqid'] = $this->uri->segment(4);
    $data['content'] = $this->driver_suggestion_model->get("*",$where);
        foreach ($data['content'] as $item){
            if($item->ds_status == "1"){
                $item->ds_status = "پذیرفته شده";
            }
            else if($item->ds_status == "0"){
                $item->ds_status = "پذیرفته نشده";
            }
            $item->ds_date = $this->date_convert($item->ds_date);
            $item->redirect_accept_suggestion = site_url(array('travelcompany', 'trip_list', 'accept_suggestion', $item->ds_driverid."/".$where['ds_reqid']));
        }
        $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
        $this->load->view('travelcompany/suggestion_list', $data);
    }//suggestion


    function  accept_suggestion(){
        $this->load->model('barname_model');
        $this->load->model('travelcompany/drivers_model');

        $where['d_id'] = $this->uri->segment(4);
        $req_id = $this->uri->segment(5);

        $data_barname_factor['bf_price']=$this->requests_model->get_barname_price($req_id);
        $data_barname_factor['bf_reqid']=$req_id;
        $data_barname_factor['bf_driverid']= $where['d_id'];
        $data_barname_factor['bf_status']="0";
        $data_barname_factor['bf_time_peyment']="30";
        if($this->barname_model->insert($data_barname_factor)){
            $data_firebase_code= $this->drivers_model->get("d_firebase_code" , $where);
            foreach ($data_firebase_code as $item){
                $firebase_code = $item->d_firebase_code;
                $title = "پیشنهاد شما قبول شد";
                $dess = "برای پرداخت بارنامه کلیک کنید";
                $this->send_to_drivers("2" ,$title , $dess , $firebase_code, $req_id);

                $msg['msg'][0] = 'success';
                $msg['msg'][1] = "با موفقیت ثبت شد.";
                $this->session->set_flashdata($msg);
                redirect(site_url(array('travelcompany', 'trip_list', 'suggestion', $req_id))); // TODO
            }
        }
        else{
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "خطا در ثبت اطلاعات";
            $this->session->set_flashdata($msg);
            redirect(site_url(array('travelcompany', 'trip_list', 'suggestion', $req_id))); // TODO
        }
    }//accept_suggestion



    function send_to_drivers($kind , $title , $message , $firebase_code , $req_id) {

        $url = 'https://fcm.googleapis.com/fcm/send';
        $fields = array(
            'to' => $firebase_code,
            'priority' => 'high',
            'time_to_live' => 40,
            'data' => array(
                "title" => $title, //title
                "message" => $message, // message
                "kind" => $kind, // kind
                "req_id" => $req_id   // req_id
            )
        );
        $fields = json_encode($fields);
        $headers = array(
            'Authorization: key=' . "AAAA2qTcEDs:APA91bEOOQ0Y3UJQKjfYMOPH4inumJhQRIZBRJtzQiaaPARloJkeRzIIxFyMvjV0BNlOgauTsXCl9Ks2NwK224JdLDshaAlPNlAQJ415mPLqpURN-0_qhWtCxaGksEUXel_cor6kPMyq2QoFE1J005sljSOnWVePFw",
            'Content-Type: application/json'
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        $result = curl_exec($ch);
        curl_close($ch);
//        echo"<br>";
//        var_dump($result);


    }// end of send_to_drivers

    function date_convert($miladi_date)
    {
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function


}//end of class
