<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');



class User_model extends CI_Model

{

	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL , $group_by= NULL , $or_like = NULL)

	{

		if($select != NULL)

			$this->db->select($select);

		if($where != NULL)

			$this->db->where($where);

		if($order_by != NULL)

			$this->db->order_by($order_by);
			
		if($group_by!= NULL)
			$this->db->group_by($group_by);
			
		if($or_like != NULL)
			$this->db->or_like($or_like);


		
		return $this->db->get('users', $limit, $offset)->result();

	}



	function update($where, $data)

	{

		$this->db->where($where);

		if($this->db->update("users", $data))

			return TRUE;

		else

			return FALSE;

	}



	function insert($data)

	{

		if($this->db->insert("users", $data))

			return $this->db->insert_id();

		else

			return FALSE;

	}



	function delete($where)

	{

		$this->db->where($where);

		if($this->db->delete("users"))

			return TRUE;

		else

			return FALSE;

	}

	function get_account($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);

		if($where != NULL)
			$this->db->where($where);

		if($order_by != NULL)
			$this->db->order_by($order_by);

		if($group_by != NULL)
			$this->db->group_by($group_by);

		$this->db->join('accounting', 'accounting.act_userid=users.usr_id', 'left');
		
		return $this->db->get('users', $limit, $offset)->result();
	}
	
	
	function to_utf8($in) 
{ 
        if (is_array($in)) { 
            foreach ($in as $key => $value) { 
                $out[to_utf8($key)] = to_utf8($value); 
            } 
        } elseif(is_string($in)) { 
            if(mb_detect_encoding($in) != "UTF-8") 
                return utf8_encode($in); 
            else 
                return $in; 
        } else { 
            return $in; 
        } 
        return $out; 
} 

}