<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Driver_transaction_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_drivers_transaction', $limit, $offset)->result();
	}




	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_drivers_transaction ', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_drivers_transaction'))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('_drivers_transaction', $data))
            return $this->db->insert_id();
		else
			return FALSE;
	}




	function change_credit($change_type , $driverid , $price , $kind , $code1="0" , $code2="0" , $code3="")
    {
        /*
         * kind = 1 ==> register gift driver code1 ==> REGISTER_DRIVER + driverid
         * kind = 2 ==> bargashte barname pas az kasr darsad ==> code1=>baename_factor_id code2=>reg_id
         */
        $this->load->model('drivers_model');
        $driver_credit = $this->drivers_model->get_driver_credit($driverid);
        $driver_credit_gift = $this->drivers_model->get_driver_credit_gift($driverid);
        if($change_type == "1"){
            $new_credit = $driver_credit + $price ;
            $where_credit['d_id'] = $driverid;
            $data_credit['d_credit'] = $new_credit;
            $new_credit_table = $driver_credit_gift + $driver_credit + $price ;
            if($this->drivers_model->update($where_credit,$data_credit)){
                $status = "1";
                while($this->insert_to_table($driverid ,$price ,$new_credit_table ,$status ,$kind , $code1 , $code2 , $code3)){
                    return TRUE;
                }
            }else{
                $this->change_credit($change_type ,$driverid , $price , $kind , $code1 , $code2 , $code3);
            }
        }else  if($change_type == "0"){

            if($price > $driver_credit_gift){
                $where_credit['d_id'] = $driverid;
                $data_credit['d_credit_gift'] = "0";
                $new_credit_table = $driver_credit_gift + $driver_credit - $price ;
                $data_credit['d_credit'] = $new_credit_table;

                if($this->drivers_model->update($where_credit,$data_credit)){
                    $status = "1";
                    while($this->insert_to_table($driverid ,$price ,$new_credit_table ,$status ,$kind , $code1 , $code2 , $code3)){
                        return TRUE;
                    }
                }else{
                    $this->change_credit($change_type ,$driverid , $price , $kind , $code1 , $code2 , $code3);
                }


            }else{
                $new_credit = $driver_credit_gift - $price ;
                $where_credit['d_id'] = $driverid;
                $data_credit['d_credit_gift'] = $new_credit;
                $new_credit_table = $driver_credit_gift + $driver_credit - $price ;

                if($this->drivers_model->update($where_credit,$data_credit)){
                    $status = "1";
                    while($this->insert_to_table($driverid ,$price ,$new_credit_table ,$status ,$kind , $code1 , $code2 , $code3)){
                        return TRUE;
                    }
                }else{
                    $this->change_credit($change_type ,$driverid , $price , $kind , $code1 , $code2 , $code3);
                }
            }


        }else if($change_type == "3"){
                $new_credit_table = $driver_credit_gift - $price  ;
                $status = "1";
                while($this->insert_to_table($driverid ,$price ,$new_credit_table ,$status ,$kind , $code1 , $code2 , $code3)){
                    return TRUE;
                }
        }


    }//change_credit

    function add_driver_transaction($change_type , $driverid , $price , $kind , $code1="0" , $code2="0" , $code3="")
    {
        $this->load->model('drivers_model');
        $new_credit = $code2;
        $status = "1";
        while($this->insert_to_table($driverid ,$price ,$new_credit ,$status ,$kind , $code1 , $code2 , $code3)){
            return TRUE;
        }
    }//change_credit



    function change_credit_gift($change_type , $driverid , $price , $kind , $code1="0" , $code2="0" , $code3="")
    {
        $this->load->model('drivers_model');
        $driver_credit = $this->drivers_model->get_driver_credit($driverid);

        if($change_type == "1"){
            $new_credit = $driver_credit + $price ;
            $where_credit['d_id'] = $driverid;
            $data_credit['d_gift_credit'] = $new_credit;
            if($this->drivers_model->update($where_credit,$data_credit)){
                $status = "1";
                while($this->insert_to_table($driverid ,$price ,$new_credit ,$status ,$kind , $code1 , $code2 , $code3)){
                    return TRUE;
                }
            }else{
                $this->increase_credit($driverid , $price , $kind , $code1 , $code2 , $code3);
            }
        }else if($change_type == "2"){// kasr gift babate komision safar
            $driver_credit_gift = $this->get_driver_gift_credit($driverid);
            $new_credit = $driver_credit_gift - $price ;
            $where_credit['d_id'] = $driverid;
            $data_credit['d_gift_credit'] = $new_credit;
            if($this->drivers_model->update($where_credit,$data_credit)){
                $status = "2";
                while($this->insert_to_table($driverid ,$price ,$new_credit ,$status ,$kind , $code1 , $code2 , $code3)){
                    return TRUE;
                }
            }
        }
    }//change_credit


    function get_driver_gift_credit($driverid)
    {
        $where['d_id'] = $driverid;
        $select = "d_gift_credit";
        $this->db->select($select);
        $this->db->where($where);
        $result = $this->db->get('_drivers', NULL, NULL)->result();
        if(empty($result)){
            return 0;
        }else{
            return $result[0]->d_gift_credit;
        }
    }//cmp_drivers_count

    function insert_to_table($driverid , $price ,$new_credit ,$status ,$kind , $code1 , $code2 , $code3){
        $data['dt_price'] = $price;
        $data['dt_new_credit'] = $new_credit;
        $data['dt_status'] = $status;
        $data['dt_code1'] = $code1;
        $data['dt_code2'] = $code2;
        $data['dt_code3'] = $code3;
        $data['dt_kind'] = $kind;
        $data['dt_driverid'] = $driverid;

        if($this->insert($data)){
            return TRUE;
        }else{
            return FALSE;
        }
    }//insert_to_table


    function get_driver_transaction($driverid , $offset , $limit){
//        $where_req['dt_status'] = "1";
        $where_req['dt_driverid'] =$driverid;
        $group_by = "dt_id";
        $order_by = "dt_id desc";
        $select = "*";
        $this->db->select($select);
        $this->db->where($where_req);
        $this->db->order_by($order_by);
        $this->db->group_by($group_by);
        return $this->db->get('_drivers_transaction', $limit, $offset)->result();
    }//get_active_request




}//end of class