<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Rate_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_rate', $limit, $offset)->result();
	}

    function get_join_req($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
    {
        if($select != NULL)
            $this->db->select($select);
        if($where != NULL)
            $this->db->where($where);
        if($order_by != NULL)
            $this->db->order_by($order_by);
        if($group_by != NULL)
            $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_rate.rate_reqid', 'left');
        return $this->db->get('_rate', $limit, $offset)->result();
    }




	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_rate ', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_rate'))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('_rate', $data))
			return TRUE;
		else
			return FALSE;
	}


    function cmp_rate($cmp_id)
    {
        $where['_requests.req_company'] = $cmp_id;
        $select = "rate_number";
        $group_by = "rate_id";
        $this->db->select($select);
        $this->db->where($where);
        $this->db->group_by($group_by);
        $this->db->join('_requests', '_requests.req_id=_rate.rate_reqid', 'left');
        $result = $this->db->get('_rate', NULL, NULL)->result();
        $total = 0 ;
        foreach ($result as $item){
            $total += $item->rate_number;
        }
        if($total != 0){
            $total /= sizeof($result);
        }
        return $total;
    }//cmp_drivers_count

	
}//end of class