<?php

// We will be using this class to define each selectbox

class SelectBox{
	public $items = array();
	public $defaultText = '';
	public $title = '';

	public function __construct($title, $default){
		$this->defaultText = $default;
		$this->title = $title;
	}

	public function addItem($name, $connection = NULL){
		$this->items[$name] = $connection;
		return $this;
	}

	public function toJSON(){
		if($this!=null){
					return json_encode($this);
		}
	}


}//SelectBox




	header('Content-type: application/json');

	if($_GET['key'] == 'category'){
		$category = new SelectBox('دسته بندی','دسته بندی');
		$url = 'http://erfan.rastakcompany.com/management/index.php/webservice/pannel/category?sub='.$_GET['key'];
		$json = @file_get_contents($url);
		$data = json_decode($json);
		$cat_list = $data->category;
		$length = count($cat_list);
		for($i = 0 ; $length > $i ; $i++ ){
			$category->addItem($cat_list[$i]->cat_name,$cat_list[$i]->id);
		}
     echo $category->toJSON();
	} // if
	else {
			$subcategory = new SelectBox('زیر دسته','زیر دسته');
			$url = 'http://erfan.rastakcompany.com/management/index.php/webservice/pannel/category?sub='.$_GET['key'];
			$json = @file_get_contents($url);
			$data = json_decode($json);
			$cat_list = $data->category;
			$length = count($cat_list);
			for($i = 0 ; $length > $i ; $i++ ){
				$subcategory->addItem($cat_list[$i]->cat_name,"A".$cat_list[$i]->id);
			}
			 echo $subcategory->toJSON();


	}

?>
