<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Cmp_mali extends CI_Controller
{
    function __construct()
    {
        parent::__construct();
        $this->load->helper('form');
        $this->load->helper('url');
        $this->load->model('main/admin_model');//TODO
        $this->load->model('config/config_model');
        $this->load->model('travelcompany/company_model');
        $this->load->library('session');
        $this->load->database();
    }
    function index()
    {
        if(!$this->config_model->check_login("ADMIN")){
            redirect(site_url('log_in'));
        }
        $company_id = $this->session->userdata("cmp_id") ;
        $where['cmp_id'] = $company_id;
        $data['content'] = $this->company_model->get("*",$where);
        $data['sidebar'] = $this->load->view("side_bar_mali", "", TRUE);
        $this->load->view("travelcompany/cmp_mali", $data);
    }//end of index function
    function date_convert($miladi_date)
    {
        error_reporting(0);
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function
}//end of class