<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Log_in extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->helper('form');
		$this->load->helper('url');
		$this->load->model('main/admin_model');
		$this->load->library('session');
		$this->load->database();
	}
	function index()
	{
		if($this->session->userdata("admin_id") != NULL && $this->session->userdata("admin_level") != NULL && $this->session->userdata("admin_status") != NULL)
		{
			if($this->session->userdata("admin_status") == "1" )
				redirect(site_url('dashboard'));
		}
		if($this->input->post('login'))
		{
			$this->load->library('form_validation');
			$this->form_validation->set_rules('email','ایمیل','required|valid_email');
			$this->form_validation->set_rules('password','رمز عبور','required');
			$this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
			$this->form_validation->set_message('valid_email','%s معتبر نیست');
			if($this->form_validation->run() != FALSE)
			{
				$where['admin_email'] = $this->input->post('email');
				$where['admin_password'] = md5($this->input->post('password'));
				$where['admin_status'] = "1";

				$valid_admin = $this->admin_model->get('*',$where);
				if(!empty($valid_admin))
				{
					if($valid_admin[0]->admin_status == "1" && $valid_admin[0]->admin_level != "0"){

            $date_new['admin_last_login'] = date("Y-m-d H:i:s");
            $this->admin_model->update($where , $date_new);

						$user_data = array(
							'admin_id' => $valid_admin[0]->admin_id,
							'admin_image' => $valid_admin[0]->admin_image,
							'admin_status' => $valid_admin[0]->admin_status,
							'admin_level' => $valid_admin[0]->admin_level,
							'admin_name' => $valid_admin[0]->admin_name);
							$this->session->set_userdata($user_data);
							redirect(site_url('dashboard')); // TODO
					}
          else{
						$msg['msg'][0] = "danger";
						$msg['msg'][1] = "اجازه دسترسی ندارید";
						$this->session->set_flashdata($msg);
						redirect(site_url('log_in'));
					}
				
				}
				else
				{
					$msg['msg'][0] = "danger";
					$msg['msg'][1] = " ایمیل یا رمز عبور اشتباه است";
					$this->session->set_flashdata($msg);
					redirect(site_url('log_in'));
				}
			}
				
		}
		$this->load->view('base/login_view');
	}
}