<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Setting extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
    $this->load->model('setting_model');
  }


    function takhlie() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "takhlie";
        $where['set_status !='] = "2";
        $data['page_name'] = "زمان تخلیه بار";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function

    function distance() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "distance";
        $where['set_status !='] = "2";
        $data['page_name'] = "شعاع ارسال";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function

    function bar_dess() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "bar_dess";
        $where['set_status !='] = "2";
        $data['page_name'] = "توضیحات بار";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function

    function bar_weight() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "bar_weight";
        $where['set_status !='] = "2";
        $data['page_name'] = "وزن بار";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function


    function bar_packet() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "bar_packet";
        $where['set_status !='] = "2";
        $data['page_name'] = "نوع بسته بندی";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function

    function bar_kind() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "bar_kind";
        $where['set_status !='] = "2";
        $data['page_name'] = "نوع بار";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function

  function device() {
      $this->config_model->check_login("ADMIN");
      $data['pagination'] = NULL;
      $like = NULL ;
      $where['set_kind'] = "device";
      $where['set_status !='] = "2";
      $data['page_name'] = "وسایل نقلیه";
      $data['content'] = $this->setting_model->get("*" , $where);
      foreach ($data['content'] as $item ){
          if($item->set_status == "0"){
              $item->set_status = "غیر فعال";
          }else{
              $item->set_status = " فعال";
          }

          $item->set_date = $this->date_convert($item->set_date);
      }
      $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
      $this->load->view('setting_list', $data);
  }//end of index function


    function peyment_kind() {
        $this->config_model->check_login("ADMIN");
        $data['pagination'] = NULL;
        $like = NULL ;
        $where['set_kind'] = "peyment_kind";
        $where['set_status !='] = "2";
        $data['page_name'] = "روش های پرداخت";
        $data['content'] = $this->setting_model->get("*" , $where);
        foreach ($data['content'] as $item ){
            if($item->set_status == "0"){
                $item->set_status = "غیر فعال";
            }else{
                $item->set_status = " فعال";
            }

            $item->set_date = $this->date_convert($item->set_date);
        }
        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view('setting_list', $data);
    }//end of index function


    function date_convert($miladi_date)
    {
        $this->load->library('jdf');
        $explode_date_time = explode(" ", $miladi_date);
        $explode_date = explode("-", $explode_date_time[0]);
        return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
    }//end of date_convert function


    function delete() {
        $where['set_id'] = $this->uri->segment(4);
        if(!is_numeric($where['set_id']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "شمارنده یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('setting/setting',$this->uri->segment(5)));
        }

        $data['content'] = $this->setting_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "مشخصات یافت نشد";
            $this->session->set_flashdata($msg);
            redirect(site_url('setting/setting',$this->uri->segment(5)));
        }

        $data_update['set_status']= "2";
        if($this->setting_model->update($where,$data_update)){
            $msg['msg'][0] = 'success';
            $msg['msg'][1] = "با موفقیت پاک شد.";
            $this->session->set_flashdata($msg);
            redirect(site_url('setting/setting/'.$this->uri->segment(5))); // TODO
        }
        else
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "خطا در ثبت اطلاعات";
            $this->session->set_flashdata($msg);
            redirect(site_url('setting/setting/'.$this->uri->segment(5))); // TODO
        }
    }//delete



    function add() {
        $this->load->library('form_validation');
        $this->config_model->check_login("ADMIN");


        if($this->input->post("edit_btn"))
        {
            $this->form_validation->set_rules('set_name','نام ','required');
            $this->form_validation->set_rules('set_status','وضعیت','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {
                $data['set_name'] = $this->input->post("set_name");
                $data['set_status'] = $this->input->post("set_status");
                $data['set_kind'] = $this->uri->segment(4);

                $config['upload_path'] = './images/setting/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('set_image'))
                {
                    $img = $this->upload->data();
                    $data['set_image'] = $img["file_name"];
                }

                if($this->setting_model->insert($data))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('setting/setting/'.$this->uri->segment(4))); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('setting/setting/add' ,$this->uri->segment(4) )));
                }
//
            }//end of check form_validation
            else{
                $msg['msg'][0] = "danger";
                $msg['msg'][1] = "خطا در ثبت اطلاعات";
                $this->session->set_flashdata($msg);
                redirect(site_url(array('setting/setting/add' ,$this->uri->segment(4) )));
            }
        }//end of check post register btn



        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view("add_setting", $data);
    }//index


    function edit() {
        $this->config_model->check_login("ADMIN");

        $where['set_id'] = $this->uri->segment(4);
        $data['content'] = $this->setting_model->get("*", $where);
        if(empty($data['content']))
        {
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "یافت نشد !";
            $this->session->set_flashdata($msg);
            redirect(site_url('setting/setting/'.$this->uri->segment(5))); // TODO
        }


        if($this->input->post("edit_btn"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('set_name','نام ','required');
            $this->form_validation->set_rules('set_status','وضعیت','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {


                $data_update['set_name'] = $this->input->post("set_name");
                $data_update['set_status'] = $this->input->post("set_status");

                $config['upload_path'] = './images/setting/';
                $config['allowed_types'] = 'gif|jpg|png|jpeg';
                $config['encrypt_name'] = 'true';
                $this->load->library('upload',$config);
                if($this->upload->do_upload('set_image'))
                {
                    $img = $this->upload->data();
                    $data_update['set_image'] = $img["file_name"];
                }

                if($this->setting_model->update($where , $data_update))
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('setting/setting/'.$this->uri->segment(5))); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('setting/setting/edit' , $this->uri->segment(5))));
                }

            }//end of check form_validation
        }//end of check post register btn

        $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
        $this->load->view("edit_setting", $data);
    }//index



}//end of class
