<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Setting_all extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
    $this->load->model('main/requests_model');
    $this->load->model('driver_suggestion_model');
    $this->load->model('setting_model');
      $this->load->model('travelcompany/colleague_model');
      $this->load->model('travelcompany/city_model');
      $this->load->model('setting_app_model');
      $this->load->model('setting_model');

  }

  function index() {
      if(!$this->config_model->check_login("ADMIN")){
          redirect(site_url('log_in'));
      }
      $data['setting'] = $this->setting_app_model->get('*');
      $data['sidebar'] = $this->load->view("side_bar_setting", "", TRUE);
      $this->load->view('setting_all_list', $data);
  }//end of index function


    function edit(){
        if(!$this->config_model->check_login("ADMIN")){
            redirect(site_url('log_in'));
        }

        if($this->input->post("btn_edit"))
        {
            $this->load->library('form_validation');
            $this->form_validation->set_rules('gift','هدیه اولیه رانندگان','required');
            $this->form_validation->set_rules('barname','کمسیون بارنامه','required');
            $this->form_validation->set_rules('laghv','جریمه لغو بارنامه','required');
            $this->form_validation->set_message('required','&#1608;&#1575;&#1585;&#1583; &#1705;&#1585;&#1583;&#1606; &#1601;&#1740;&#1604;&#1583; %s &#1575;&#1604;&#1586;&#1575;&#1605;&#1740; &#1575;&#1587;&#1578;');
            if($this->form_validation->run() != FALSE)
            {


                $data_gift['sa_value'] = $this->input->post("gift");
                $where_gift['sa_id'] = "1";


                $data_laghv['sa_value'] = $this->input->post("laghv");
                $where_laghv['sa_id'] = "2";

                $data_barname['sa_value'] = $this->input->post("barname");
                $where_barname['sa_id'] = "3";


                $res = $this->setting_app_model->update($where_gift , $data_gift);
                $res2 = $this->setting_app_model->update($where_laghv , $data_laghv);
                $res3 = $this->setting_app_model->update($where_barname , $data_barname);



                if($res && $res2 && $res3)
                {
                    $msg['msg'][0] = 'success';
                    $msg['msg'][1] = "با موفقیت ثبت شد.";
                    $this->session->set_flashdata($msg);
                    redirect(site_url('setting_all')); // TODO
                }
                else
                {
                    $msg['msg'][0] = "danger";
                    $msg['msg'][1] = "خطا در ثبت اطلاعات";
                    $this->session->set_flashdata($msg);
                    redirect(site_url(array('setting_all')));
                }

            }//end of check form_validation
        }else{
            $msg['msg'][0] = "danger";
            $msg['msg'][1] = "خطا در ثبت اطلاعات";
            $this->session->set_flashdata($msg);
            redirect(site_url(array('setting_all')));
        }


    }



}//end of class
