<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Log_in extends CI_Controller
{
	function __construct()
	{
		parent::__construct();
		$this->load->helper('form');
		$this->load->helper('url');
        $this->load->model('travelcompany/company_model');
		$this->load->library('session');
		$this->load->database();
	}
	function index()
	{
		if($this->session->userdata("company_pannel") != NULL )
		{
                redirect(site_url('travelcompany/dashboard')); // TODO
		}
		else if($this->input->post('login'))
		{
			$this->load->library('form_validation');
			$this->form_validation->set_rules('email','شماره کاربری','required');
			$this->form_validation->set_rules('password','رمز عبور','required');
			$this->form_validation->set_message('required','وارد کردن فیلد %s الزامی است');
			$this->form_validation->set_message('valid_email','%s معتبر نیست');
			if($this->form_validation->run() != FALSE)
			{
				$where['cmp_username'] = $this->input->post('email');
				$where['cmp_password'] = $this->input->post('password');
//				$where['cmp_status'] = "1";

                $data_cmp = $this->company_model->get('*',$where);
				if(!empty($data_cmp))
				{

				        if ($data_cmp[0]->cmp_status == "1"){
                            $company_data = array(
                                'company_pannel' => "1",
                                'cmp_id' => $data_cmp[0]->cmp_id,
                                'cmp_image' => $data_cmp[0]->cmp_image,
                                'cmp_status' => $data_cmp[0]->cmp_status,
                                'cmp_name' => $data_cmp[0]->cmp_name);
                            $this->session->set_userdata($company_data);

                            if($data_cmp[0]->cmp_lat == NULL){
                                redirect(site_url('travelcompany/company_position')); // TODO
                            }else{
                                redirect(site_url('travelcompany/dashboard')); // TODO
                            }
                        }
                        else  if ($data_cmp[0]->cmp_status == "0"){
                            $msg['msg'][0] = "danger";
                            $msg['msg'][1] = "حساب کاربری شما هنوز تایید نشده است منتظر تایید ناظر بمانید";
                            $this->session->set_flashdata($msg);
                            redirect(site_url('travelcompany/log_in'));
                        }
                        else  if ($data_cmp[0]->cmp_status == "2"){
                            $msg['msg'][0] = "danger";
                            $msg['msg'][1] = "حساب کاربری شما مسدود شده است جهت اطلاعات بیشتر با پشتیبانی تماس حاصل فرمایید";
                            $this->session->set_flashdata($msg);
                            redirect(site_url('travelcompany/log_in'));
                        }




				}
				else
				{
					$msg['msg'][0] = "danger";
					$msg['msg'][1] = " ایمیل یا رمز عبور اشتباه است";
					$this->session->set_flashdata($msg);
					redirect(site_url('travelcompany/log_in'));
				}
			}
				
		}
		$this->load->view('travelcompany/login_view');
	}
}