<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class Submit_trip extends CI_Controller {
  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->load->model('config/config_model');
    $this->load->model('main/requests_model');
    $this->load->model('travelcompany/colleague_model');
    $this->load->model('travelcompany/city_model');
    $this->load->model('setting_model');
  }
    function index() {
      if(!$this->config_model->check_login("COMPANY")){
          redirect(site_url('travelcompany/log_in'));
      }
      $this->load->model('travelcompany/company_model');

     $customer_id = $this->company_model->get_customer_id($this->session->userdata("cmp_id"));
     if($customer_id == NULL){
         $this->load->view("travelcompany/register_balance", NULL);
     }else {


         $location['location']['latitude'] = "35.6891980";
         $location['location']['longitude'] = "51.3889740";
         $data['map'] = $this->load->view('travelcompany/submit_trip_map_new', $location, TRUE);


         $where_peyment_kind["set_kind"] = "peyment_kind";
         $where_peyment_kind["set_status"] = "1";
         $data['peyment_kind'] = $this->setting_model->get('set_id , set_name', $where_peyment_kind);

         $where_device["set_kind"] = "device";
         $where_device["set_status"] = "1";
         $data['device'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "bar_kind";
         $data['bar_kind'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "bar_packet";
         $data['bar_packet'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "bar_weight";
         $data['bar_weight'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "bar_dess";
         $data['bar_dess'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "distance";
         $data['distance'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_device["set_kind"] = "takhlie";
         $data['takhlie'] = $this->setting_model->get('set_id , set_name', $where_device);

         $where_colleague["co_cmp_id"] = $this->session->userdata("cmp_id");
         $where_colleague["co_status"] = "1";
         $data['colleague'] = $this->colleague_model->get('co_id , co_name , co_family', $where_colleague);


         $where_device["set_kind"] = "device";
         $where_device["set_status"] = "1";
         $data['device'] = $this->setting_model->get('set_id , set_name', $where_device);

         $data['cities'] = $this->city_model->get('id , name');

         $data['sidebar'] = $this->load->view("travelcompany/side_bar", "", TRUE);
//    $this->load->view('select_chosen', $data);
         $this->load->view('travelcompany/submit_trip_form', $data);
     }
  }//end of index function
    function driver_alarm($distance , $device , $req_id){
      $this->load->model('travelcompany/drivers_model');
      $data = $this->drivers_model->get_drivers_active($distance , $device);
      foreach ($data as $item){
          $firebase_code = $item->d_firebase_code;
          $title = "اعلام بار جدید در محدوده شما";
          $dess = "برای دیدن جزییات کلیک کنید";
          $this->send_to_drivers("1" ,$title , $dess , $firebase_code, $req_id);
      }
    }//driver_alarm
    function driver_alarm_test(){
        $this->load->model('travelcompany/drivers_model');
        $data = $this->drivers_model->get_drivers_active("" , "");
//        var_dump($data);
        foreach ($data as $item){
            $firebase_code = $item->d_firebase_code;
            $title = "اعلام بار جدید در محدوده شما";
            $dess = "برای دیدن جزییات کلیک کنید";
            $this->send_to_drivers("1" ,$title , $dess , $firebase_code, "");
        }
    }//driver_alarm
    function send_to_drivers($kind , $title , $message , $firebase_code , $req_id) {

        $url = 'https://fcm.googleapis.com/fcm/send';
        $fields = array(
            'to' => $firebase_code,
            'priority' => 'high',
            'time_to_live' => 40,
            'data' => array(
                "title" => $title, //title
                "message" => $message, // message
                "kind" => $kind, // kind
                "req_id" => $req_id   // req_id
            )
        );
        $fields = json_encode($fields);
        $headers = array(
            'Authorization: key=' . "AAAA2qTcEDs:APA91bEOOQ0Y3UJQKjfYMOPH4inumJhQRIZBRJtzQiaaPARloJkeRzIIxFyMvjV0BNlOgauTsXCl9Ks2NwK224JdLDshaAlPNlAQJ415mPLqpURN-0_qhWtCxaGksEUXel_cor6kPMyq2QoFE1J005sljSOnWVePFw",
            'Content-Type: application/json'
        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);
        $result = curl_exec($ch);
        curl_close($ch);
//        echo"<br>";
//        var_dump($result);


    }// end of send_to_drivers
}//end of class
