<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
date_default_timezone_set('Asia/Tehran');


class Base_function extends CI_Controller {


  private $api_key = "";
  private $sms_pannel_username= "";
  private $sms_pannel_password= "";
  private $sms_pannel_line_number= "";


  function __construct() {
    parent::__construct();
    $this->load->helper('form');
    $this->load->helper('url');
    $this->load->library('session');
    $this->load->database();
    $this->api_key = "";
    $this->sms_pannel_username = "9178177315";
    $this->sms_pannel_password = "2372";
    $this->sms_pannel_line_number = "10009170003489";
  }

  function index() {

  }//end of index function

  function sms_pannel_get_credit() // mashhah_host get credit of pannel
  {
    ini_set("soap.wsdl_cache_enabled", "0");
    $client = new SoapClient("http://87.107.121.52/post/send.asmx?wsdl");
    $getcredit_parameters = array(
      "username"=>$this->sms_pannel_username, // smspanel username
      "password"=>$this->sms_pannel_password // smspanel password
    );
    $credit = $client->GetCredit($getcredit_parameters)->GetCreditResult;
    return $credit ;
}// end of sms_pannel_get_credit



  function send_sms() // mashhah_host send_sms
  {
    $mobile = "09120917577";
    $sms_text = "تست";
    ini_set("soap.wsdl_cache_enabled", "0");
    $client = new SoapClient("http://87.107.121.52/post/send.asmx?wsdl");
    $encoding = "UTF-8";//CP1256, CP1252
    $textMessage = iconv($encoding, 'UTF-8//TRANSLIT',$sms_text);
    $sendsms_parameters = array(
      'username' => sms_pannel_username,
      'password' => sms_pannel_password,
      'from' => sms_pannel_line_number, // smspanel number
      'to' => array($mobile),
      'text' => $textMessage,
      'isflash' => false,
      'udh' => "",
      'recId' => array(0),
      'status' => 0
    );
    $status = $client->SendSms($sendsms_parameters)->SendSmsResult;
    return $status ;
  }// end of send_sms


  function date_convert($miladi_date)
  {
    $this->load->library('jdf');
    $explode_date_time = explode(" ", $miladi_date);
    $explode_date = explode("-", $explode_date_time[0]);
    return $this->jdf->gregorian_to_jalali($explode_date[0], $explode_date[1], $explode_date[2], "/")." ".$explode_date_time[1];
  }//end of date_convert function




}//end of class
