<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Driver_suggestion_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_driver_suggestion ', $limit, $offset)->result();
	}




	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_driver_suggestion ', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_driver_suggestion '))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('_driver_suggestion ', $data))
			return TRUE;
		else
			return FALSE;
	}

	function get_count_suggest($reg_id)
	{

	    $where['ds_reqid'] = $reg_id;
        $data = $this->get("ds_id",$where);
	    return sizeof($data);

	}//get_count_suggest

    function get_req_id($ds_id)
    {
        $where['ds_id'] = $ds_id;
        $data = $this->get("ds_reqid",$where);
        if(!empty($data)){
            return $data[0]->ds_reqid;
        }else{
            return "0";
        }
    }//get_req_id

    function get_driverid($ds_id)
    {
        $where['ds_id'] = $ds_id;
        $data = $this->get("ds_driverid",$where);
        if(!empty($data)){
            return $data[0]->ds_driverid;
        }else{
            return "0";
        }
    }//get_driverid


    function get_bar_price($reqid , $driverid)
    {
        $where['ds_reqid'] = $reqid;
        $where['ds_driverid'] = $driverid;
        $where['ds_status'] = "1";
        $data = $this->get("ds_price",$where);
        if(!empty($data)){
            return $data[0]->ds_price;
        }else{
            return "0";
        }
    }//get_bar_price
    //
       function accept_suggestion($reqid , $driverid)
    {
        $where['ds_reqid'] = $reqid;
        $where['ds_driverid'] = $driverid;
        $where['ds_status'] = "0";
        $data['ds_status'] = "1";
        return $this->update($where,$data );
    }//get_bar_price




	
}//end of class