<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Firebase_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		
		return $this->db->get('users', $limit, $offset)->result();
	}
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update("users", $data))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert("users", $data))
			return TRUE;
		else
			return FALSE;
	}
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete("users"))
			return TRUE;
		else
			return FALSE;
	}
	
}