<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Admin_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $where_in = NULL , $or_like = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		if($where_in != NULL)
			$this->db->where_in($where_in);
    if($or_like != NULL)
      $this->db->or_like($or_like);
		return $this->db->get('_admins', $limit, $offset)->result();


	}// end of get

	function insert($data)
	{
		if($this->db->insert('_admins', $data))
			return TRUE;
		else
			return FALSE;
	}// end of insert

	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_admins', $data))
			return TRUE;
		else
			return FALSE;
	}// end of update

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_admins'))
			return TRUE;
		else
			return FALSE;
	}// end of delete


  function get_user_name_by_id($where )
  {
    $this->db->select("admin_name");
    $this->db->where($where);
    $data =  $this->db->get('_admins')->result();
    return $data[0]->admin_name;
  }// end of get_user_name_by_id


} // end of Update_model