<?php if (!defined('BASEPATH')) exit('No direct script access allowed');


class User_model extends CI_Model {

  function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL, $or_like = NULL) {

    if ($select != NULL)

      $this->db->select($select);

    if ($where != NULL)

      $this->db->where($where);

    if ($order_by != NULL)

      $this->db->order_by($order_by);

    if ($group_by != NULL)
      $this->db->group_by($group_by);

    if ($or_like != NULL)
      $this->db->or_like($or_like);


    return $this->db->get('_users', $limit, $offset)->result();

  }


  function update($where, $data) {
    $this->db->where($where);
    if ($this->db->update("_users", $data))
      return TRUE;
    else
      return FALSE;
  }


  function insert($data) {

    if ($this->db->insert("_users", $data))
      return $this->db->insert_id();
    else
      return FALSE;
  }


  function delete($where) {
    $this->db->where($where);
    if ($this->db->delete("_users"))
      return TRUE;
    else
      return FALSE;
  }

  function increase_credit($user_id, $credit) {
    $sql = "UPDATE _users SET user_credit= user_credit + '$credit' WHERE user_id= '$user_id' ";
    if($this->db->query($sql)){
      $sql = "SELECT user_credit From _users  WHERE user_id= '$user_id' ";
      $result = $this->db->query($sql)->result();
      return $result[0]->user_credit;
    }else{
      return FALSE;
    }
  }// end of increase_credit


  function decrease_credit($user_id, $credit) {
    $sql = "UPDATE _users SET user_credit= user_credit - '$credit' WHERE user_id= '$user_id' ";
    if($this->db->query($sql)){
      $sql = "SELECT user_credit From _users  WHERE user_id= '$user_id' ";
      $result = $this->db->query($sql)->result();
      return $result[0]->user_credit;
    }else{
      return FALSE;
    }
  }// end of increase_credit

  function get_user_name_by_id($where)
  {
    $this->db->select("user_name");
    $this->db->where($where);
    $data =  $this->db->get('_users')->result();
    return $data[0]->user_name;
  }// end of get_user_name_by_id

  function get_fcm_by_id($where)
  {
    $this->db->select("user_fcm");
    $this->db->where($where);
    $data =  $this->db->get('_users')->result();
    return $data[0]->user_fcm;
  }// end of get_fcm_by_id


  function get_user_credit($userid)
  {
    $where['user_id'] = $userid ;
    $this->db->select("user_credit");
    $this->db->where($where);
    $data =  $this->db->get('_users')->result();
    return $data[0]->user_credit;
  }// end of get_user_credit

  function get_username_by_mobile($mobile)
  {
    $where['user_mobile']= $mobile ;
    $this->db->select("user_name");
    $this->db->where($where);
    $data =  $this->db->get('_users')->result();
    return $data[0]->user_name;
  }// end of get_fcm_by_id



}
