<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Notification_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);

		if($where != NULL)
			$this->db->where($where);

		if($order_by != NULL)
			$this->db->order_by($order_by);

		if($group_by != NULL)
			$this->db->group_by($group_by);

		$this->db->join('send_notification', 'send_notification.snf_notificationid=notification.ntf_id', 'left');

		return $this->db->get('notification', $limit, $offset)->result();
	}

	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('notification', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('notification'))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('notification', $data))
			return $this->db->insert_id();
		else
			return FALSE;
	}

	function insert_send($data)
	{
		if($this->db->insert('send_notification', $data))
			return TRUE;
		else
			return FALSE;
	}

	function update_send($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('send_notification', $data))
			return TRUE;
		else
			return FALSE;
	}

	function insert_batch($data)
	{
		if($this->db->insert_batch('send_notification', $data))
			return TRUE;
		else
			return FALSE;
	}

	
}//end of class