<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Requests_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL , $group_by= NULL , $or_like = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
			
		if($where != NULL)
			$this->db->where($where);
			
		if($or_like != NULL)
			$this->db->or_like($or_like);
			
		if($order_by != NULL)
			$this->db->order_by($order_by);

		if($group_by!= NULL)
			$this->db->group_by($group_by);

                $this->db->join('users', 'users.usr_id=requests.userid', 'left');
                $this->db->join('destinitions', 'destinitions.father_id = requests.id', 'left');
                $this->db->join('trip_online', 'trip_online.req_id = requests.id', 'left');
                $this->db->join('taxi', 'taxi.id = trip_online.driverid', 'left');
		
		return $this->db->get('requests', $limit, $offset)->result();

	}
	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update("requests", $data))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert("requests", $data))
			return $this->db->insert_id();
		else
			return FALSE;
	}
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete("requests"))
			return TRUE;
		else
			return FALSE;
	}
	
}