<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Setting_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('_setting ', $limit, $offset)->result();
	}




	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('_setting ', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('_setting '))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('_setting ', $data))
			return TRUE;
		else
			return FALSE;
	}


    function get_device_kind($device)
    {
        $where['set_id'] = $device ;
        $this->db->select("set_name");
        $this->db->where($where);
        $data =  $this->db->get('_setting')->result();
        if(empty($data)){
            return "وارد نشده است";
        }else{
            return $data[0]->set_name;
        }

    }



    function get_setting_name($id)
    {
        $where['set_id'] = $id ;
        $this->db->select("set_name");
        $this->db->where($where);
        $data =  $this->db->get('_setting')->result();
        if(empty($data)){
            return "وارد نشده است";
        }else{
            return $data[0]->set_name;
        }

    }

    function get_deviceid_by_name($device_name)
    {
        $where['set_name'] = $device_name ;
        $this->db->select("set_id");
        $this->db->where($where);
        $data =  $this->db->get('_setting')->result();
        if(empty($data)){
            return "0";
        }else{
            return $data[0]->set_id;
        }

    }

	
}//end of class