<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class City_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		if($group_by != NULL)
			$this->db->group_by($group_by);
		return $this->db->get('cities', $limit, $offset)->result();
	}


    function get_province($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL, $group_by = NULL)
    {
        if($select != NULL)
            $this->db->select($select);
        if($where != NULL)
            $this->db->where($where);
        if($order_by != NULL)
            $this->db->order_by($order_by);
        if($group_by != NULL)
            $this->db->group_by($group_by);
        return $this->db->get('provinces', $limit, $offset)->result();
    }


    function get_city_name($id){
        $where['id'] = $id ;
        $data = $this->get("name",$where);
        if(!empty($data)){
                return $data[0]->name;
        }else{
            return "یافت نشد";
        }
    }//get_city_name


    function get_province_name($id){
        $where['id'] = $id ;
        $data = $this->get_province("name",$where);
        if(!empty($data)){
            return $data[0]->name;
        }else{
            return "یافت نشد";
        }
    }//get_province_name


	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update('cities', $data))
			return TRUE;
		else
			return FALSE;
	}

	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete('cities'))
			return TRUE;
		else
			return FALSE;
	}

	function insert($data)
	{
		if($this->db->insert('cities', $data))
			return TRUE;
		else
			return FALSE;
	}

	
}//end of class