<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Trip_information_model extends CI_Model
{
	function get($select = NULL, $where = NULL, $limit = NULL, $offset = NULL, $order_by = NULL)
	{
		if($select != NULL)
			$this->db->select($select);
		if($where != NULL)
			$this->db->or_where($where);
		if($order_by != NULL)
			$this->db->order_by($order_by);
		$this->db->join('trip_driver', 'trip_driver.tripid=request_taxi.id', 'left');
		return $this->db->get('request_taxi', $limit, $offset)->result();
	}


	function update($where, $data)
	{
		$this->db->where($where);
		if($this->db->update("request_taxi", $data))
			return TRUE;
		else
			return FALSE;
	}
	function insert($data)
	{
		if($this->db->insert("request_taxi", $data))
			return TRUE;
		else
			return FALSE;
	}
	function delete($where)
	{
		$this->db->where($where);
		if($this->db->delete("request_taxi"))
			return TRUE;
		else
			return FALSE;
	}
	
}